{-# LANGUAGE MagicHash #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE QuantifiedConstraints #-}
{-# LANGUAGE RankNTypes #-}
{-# LANGUAGE PolyKinds #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE CPP #-}
{-# OPTIONS_GHC -fno-warn-overlapping-patterns #-}
{-# OPTIONS_GHC -fno-warn-missing-methods #-}
#if __GLASGOW_HASKELL__ >= 800
{-# OPTIONS_GHC -fno-warn-redundant-constraints #-}
#else
{-# OPTIONS_GHC -fno-warn-duplicate-constraints #-}
#endif

module Data.Curry_Map
  ( C_Map (..)
  , d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , nd_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  , d_C_empty
  , d_C_singleton
  , d_C_fromList
  , nd_C_fromList
  , d_C_insert
  , nd_C_insert
  , d_C_insertWith
  , nd_C_insertWith
  , d_C_insertList
  , nd_C_insertList
  , d_C_insertListWith
  , nd_C_insertListWith
  , d_C_delete
  , nd_C_delete
  , d_C_deleteAll
  , nd_C_deleteAll
  , d_C_adjust
  , nd_C_adjust
  , d_C_splitLookup
  , nd_C_splitLookup
  , d_C_union
  , nd_C_union
  , d_C_unionWith
  , nd_C_unionWith
  , d_C_difference
  , nd_C_difference
  , d_C_intersection
  , nd_C_intersection
  , d_C_intersectionWith
  , nd_C_intersectionWith
  , d_C_foldrWithKey
  , nd_C_foldrWithKey
  , d_C_mapWithKey
  , nd_C_mapWithKey
  , d_C_filterWithKey
  , nd_C_filterWithKey
  , d_C_size
  , d_C_null
  , d_C_member
  , nd_C_member
  , d_C_lookup
  , nd_C_lookup
  , d_C_findWithDefault
  , nd_C_findWithDefault
  , d_C_lookupMin
  , d_C_lookupMax
  , d_C_toList
  , d_C_keys
  , d_C_elems
  , d_C_toPreOrderList
  , d_C_sortWithMap
  , nd_C_sortWithMap )
  where

import Basics
import qualified Data.Curry_Maybe
import qualified Curry_Prelude


data C_Map t0 t1
  = C_Tip
  | C_Bin t0 t1 Curry_Prelude.C_Int (C_Map t0 t1) (C_Map t0 t1)
  | Choice_C_Map Cover ID (C_Map t0 t1) (C_Map t0 t1)
  | Choices_C_Map Cover ID [C_Map t0 t1]
  | Fail_C_Map Cover FailInfo
  | Guard_C_Map Cover Constraints (C_Map t0 t1)

instance (Curry t0, Curry t1) => Show (C_Map t0 t1) where
  showsPrec d (Choice_C_Map cd i x y) = showsChoice d cd i x y
  showsPrec d (Choices_C_Map cd i xs) = showsChoices d cd i xs
  showsPrec d (Guard_C_Map cd c e) = showsGuard d cd c e
  showsPrec _ (Fail_C_Map cd info) = showChar '!'
  showsPrec _ C_Tip = showString "Tip"
  showsPrec _ (C_Bin x1 x2 x3 x4 x5) = showString "(Bin" . (showChar ' ' .
    (shows x1 . (showChar ' ' . (shows x2 . (showChar ' ' . (shows x3 .
    (showChar ' ' . (shows x4 . (showChar ' ' . (shows x5 . showChar
    ')'))))))))))

instance (Curry t0, Curry t1) => Read (C_Map t0 t1) where
  readsPrec d s = readParen False (\r -> [(C_Tip, r0) | (_, r0) <- readQualified
    "Data.Map" "Tip" r]) s ++ readParen ((>) d 10) (\r -> [(C_Bin x1 x2 x3 x4 x5
    , r5) | (_, r0) <- readQualified "Data.Map" "Bin" r, (x1, r1) <- readsPrec
    11 r0, (x2, r2) <- readsPrec 11 r1, (x3, r3) <- readsPrec 11 r2, (x4, r4) <-
    readsPrec 11 r3, (x5, r5) <- readsPrec 11 r4]) s

instance NonDet (C_Map t0 t1) where
  choiceCons = Choice_C_Map
  choicesCons = Choices_C_Map
  failCons = Fail_C_Map
  guardCons = Guard_C_Map
  try (Choice_C_Map cd i x y) = tryChoice cd i x y
  try (Choices_C_Map cd i xs) = tryChoices cd i xs
  try (Fail_C_Map cd info) = Fail cd info
  try (Guard_C_Map cd c e) = Guard cd c e
  try x = Val x
  match f _ _ _ _ _ (Choice_C_Map cd i x y) = f cd i x y
  match _ f _ _ _ _ (Choices_C_Map cd i@(NarrowedID _ _) xs) = f cd i xs
  match _ _ f _ _ _ (Choices_C_Map cd i@(FreeID _ _) xs) = f cd i xs
  match _ _ _ _ _ _ (Choices_C_Map cd i _) = error
    ("Data.Map.Map.match: Choices with ChoiceID " ++ show i)
  match _ _ _ f _ _ (Fail_C_Map cd info) = f cd info
  match _ _ _ _ f _ (Guard_C_Map cd c e) = f cd c e
  match _ _ _ _ _ f x = f x

instance (Curry t0, Curry t1) => Generable (C_Map t0 t1) where
  generate s c = Choices_C_Map c (freeID [0, 5] s) [C_Tip, C_Bin (generate
    (leftSupply (leftSupply (leftSupply s))) c) (generate (rightSupply
    (leftSupply (leftSupply s))) c) (generate (rightSupply (leftSupply s)) c)
    (generate (leftSupply (rightSupply s)) c) (generate (rightSupply
    (rightSupply s)) c)]

instance (Curry t0, Curry t1) => NormalForm (C_Map t0 t1) where
  ($!!) cont C_Tip d cs = cont C_Tip d cs
  ($!!) cont (C_Bin x1 x2 x3 x4 x5) d cs = ($!!) (\y1 d cs -> ($!!) (\y2 d cs ->
    ($!!) (\y3 d cs -> ($!!) (\y4 d cs -> ($!!) (\y5 d cs -> cont (C_Bin y1 y2
    y3 y4 y5) d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($!!) cont (Choice_C_Map cd i x y) d cs = nfChoice cont cd i x y cd cs
  ($!!) cont (Choices_C_Map cd i xs) d cs = nfChoices cont cd i xs d cs
  ($!!) cont (Guard_C_Map cd c e) d cs = guardCons cd c (($!!) cont e d (addCs c
    cs))
  ($!!) _ (Fail_C_Map cd info) _ _ = failCons cd info
  ($##) cont C_Tip d cs = cont C_Tip d cs
  ($##) cont (C_Bin x1 x2 x3 x4 x5) d cs = ($##) (\y1 d cs -> ($##) (\y2 d cs ->
    ($##) (\y3 d cs -> ($##) (\y4 d cs -> ($##) (\y5 d cs -> cont (C_Bin y1 y2
    y3 y4 y5) d cs) x5 d cs) x4 d cs) x3 d cs) x2 d cs) x1 d cs
  ($##) cont (Choice_C_Map cd i x y) d cs = gnfChoice cont cd i x y cd cs
  ($##) cont (Choices_C_Map cd i xs) d cs = gnfChoices cont cd i xs d cs
  ($##) cont (Guard_C_Map cd c e) d cs = guardCons cd c (($##) cont e d (addCs c
    cs))
  ($##) _ (Fail_C_Map cd info) _ _ = failCons cd info
  showCons C_Tip = "Data.Map.Tip"
  showCons (C_Bin _ _ _ _ _) = "Data.Map.Bin _ _ _ _ _"
  showCons x = error ("Data.Map.Map.showCons: no constructor: " ++ show x)
  searchNF _ cont C_Tip = cont C_Tip
  searchNF search cont (C_Bin x1 x2 x3 x4 x5) = search (\y1 -> search (\y2 ->
    search (\y3 -> search (\y4 -> search (\y5 -> cont (C_Bin y1 y2 y3 y4 y5))
    x5) x4) x3) x2) x1
  searchNF _ _ x = error ("Data.Map.Map.searchNF: no constructor: " ++ show x)

instance (Curry t0, Curry t1) => Unifiable (C_Map t0 t1) where
  (=.=) C_Tip C_Tip d cs = C_True
  (=.=) (C_Bin x1 x2 x3 x4 x5) (C_Bin y1 y2 y3 y4 y5) d cs = (&) ((=:=) x1 y1 d
    cs) ((&) ((=:=) x2 y2 d cs) ((&) ((=:=) x3 y3 d cs) ((&) ((=:=) x4 y4 d cs)
    ((=:=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  (=.<=) C_Tip C_Tip d cs = C_True
  (=.<=) (C_Bin x1 x2 x3 x4 x5) (C_Bin y1 y2 y3 y4 y5) d cs = (&) ((=:<=) x1 y1
    d cs) ((&) ((=:<=) x2 y2 d cs) ((&) ((=:<=) x3 y3 d cs) ((&) ((=:<=) x4 y4 d
    cs) ((=:<=) x5 y5 d cs) d cs) d cs) d cs) d cs
  (=.<=) a b cd _ = Fail_C_Bool cd (unificationFail (showCons a) (showCons b))
  bind cd i C_Tip = (i :=: ChooseN 0 0) : concat []
  bind cd i (C_Bin x3 x4 x5 x6 x7) = (i :=: ChooseN 1 5) : concat [bind cd
    (leftID (leftID (leftID i))) x3, bind cd (rightID (leftID (leftID i))) x4
    , bind cd (rightID (leftID i)) x5, bind cd (leftID (rightID i)) x6, bind cd
    (rightID (rightID i)) x7]
  bind d i (Choice_C_Map cd j x y) = [ConstraintChoice cd j (bind d i x) (bind d
    i y)]
  bind d i (Choices_C_Map cd j@(FreeID _ _) xs) = bindOrNarrow d i cd j xs
  bind d i (Choices_C_Map cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd j
    (map (bind d i) xs)]
  bind _ _ (Choices_C_Map cd i _) = error
    ("Data.Map.Map.bind: Choices with ChoiceID: " ++ show i)
  bind _ _ (Fail_C_Map cd info) = [Unsolvable info]
  bind d i (Guard_C_Map cd c e) = getConstrList c ++ bind d i e
  lazyBind cd i C_Tip = (i :=: ChooseN 0 0) : []
  lazyBind cd i (C_Bin x3 x4 x5 x6 x7) = (i :=: ChooseN 1 5) : [leftID (leftID
    (leftID i)) :=: LazyBind (lazyBind cd (leftID (leftID (leftID i))) x3)
    , rightID (leftID (leftID i)) :=: LazyBind (lazyBind cd (rightID (leftID
    (leftID i))) x4), rightID (leftID i) :=: LazyBind (lazyBind cd (rightID
    (leftID i)) x5), leftID (rightID i) :=: LazyBind (lazyBind cd (leftID
    (rightID i)) x6), rightID (rightID i) :=: LazyBind (lazyBind cd (rightID
    (rightID i)) x7)]
  lazyBind d i (Choice_C_Map cd j x y) = [ConstraintChoice cd j (lazyBind d i x)
    (lazyBind d i y)]
  lazyBind d i (Choices_C_Map cd j@(FreeID _ _) xs) = lazyBindOrNarrow d i cd j
    xs
  lazyBind d i (Choices_C_Map cd j@(NarrowedID _ _) xs) = [ConstraintChoices cd
    j (map (lazyBind d i) xs)]
  lazyBind _ _ (Choices_C_Map cd i _) = error
    ("Data.Map.Map.lazyBind: Choices with ChoiceID: " ++ show i)
  lazyBind _ _ (Fail_C_Map cd info) = [Unsolvable info]
  lazyBind d i (Guard_C_Map cd c e) = getConstrList c ++ [i :=: LazyBind
    (lazyBind d i e)]

instance (Curry t0, Curry t1) => Curry (C_Map t0 t1) where

d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Map t1 t0)
d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Eq (acceptCs id
    (d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
    x1 x2))
    (d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
    x1 x2 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 r
    cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Eq#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Eq#Data.Map.Map" (showCons
    x3))

nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq (C_Map t1 t0)
nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Eq (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
    x1 x2)))
    (nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map
    x1 x2 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 l s
    cd cs) (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1
    x2 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 z s cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 e s cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Eq#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Eq#Data.Map.Map" (showCons
    x3))

d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> C_Map t1 t0
  -> C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
  (d_C_size x3 cd cs) (d_C_size x4 cd cs) cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (Curry_Prelude.d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
  x1 x2) (d_C_toList x3 cd cs) (d_C_toList x4 cd cs) cd cs) cd cs

nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> C_Map t1 t0
  -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.d_OP_amp_amp
  (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
  (d_C_size x3 cd cs) (d_C_size x4 cd cs) cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_lbracket_rbracket
  (wrapNX id
  (Curry_Prelude.nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_lparen_comma_rparen
  x1 x2)) (d_C_toList x3 cd cs) (d_C_toList x4 cd cs) s0 cd cs) cd cs

d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> Cover
  -> ConstStore -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 cd cs =
  acceptCs id (Curry_Prelude.d_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq
  (d_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2))

nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Eq t0) -> IDSupply
  -> Cover -> ConstStore -> Func (C_Map t1 t0) (Func (C_Map t1 t0)
  Curry_Prelude.C_Bool)
nd_OP_uscore_impl_hash_slash_eq_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2 s cd cs =
  wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_OP_uscore_def_hash_slash_eq_hash_Prelude_dot_Eq (wrapNX id
  (nd_OP_uscore_inst_hash_Prelude_dot_Eq_hash_Data_dot_Map_dot_Map x1 x2))))

nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data (C_Map t1 t0)
nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Data (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2)))
    (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 l s
    cd cs) (nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1
    x2 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Data#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Data#Data.Map.Map"
    (showCons x3))

d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_Map
  t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 cd cs =
  case x3 of
  C_Tip -> d_C__case_58 x4 cd cs
  C_Bin x10 x11 x12 x13 x14 -> d_C__case_57 x14 x2 x1 x13 x12 x11 x10 x4 cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 r x4 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 z x4 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 e x4 cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail
    "Data.Map._impl#===#Prelude.Data#Data.Map.Map" [show x1, show x2, show x3
    , show x4] info)
  _ -> failCons cd (consFail "Data.Map._impl#===#Prelude.Data#Data.Map.Map"
    (showCons x3))

nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> C_Map t1
  t0 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.C_Bool
nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 s cd cs =
  case x3 of
  C_Tip -> d_C__case_58 x4 cd cs
  C_Bin x10 x11 x12 x13 x14 -> let s0 = s
    in s0 `seq` nd_C__case_57 x14 x2 x1 x13 x12 x11 x10 x4 s0 cd cs
  Choice_C_Map d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 l x4 s cd cs)
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 r x4 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 z x4 s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 e x4 s cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail
    "Data.Map._impl#===#Prelude.Data#Data.Map.Map" [show x1, show x2, show x3
    , show x4] info)
  _ -> failCons cd (consFail "Data.Map._impl#===#Prelude.Data#Data.Map.Map"
    (showCons x3))

nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> IDSupply
  -> Cover -> ConstStore -> C_Map t1 t0
nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map x1 x2 s cd cs =
  let s10 = s
  in s10 `seq` (let s9 = leftSupply s10
                    s5 = rightSupply s10
  in s9 `seq` (s5 `seq` choice C_Tip (let s6 = leftSupply s5
                                          s7 = rightSupply s5
                                          s0 = leftSupply s6
                                          s1 = rightSupply s6
                                          s2 = leftSupply s7
                                          s8 = rightSupply s7
                                          s3 = leftSupply s8
                                          s4 = rightSupply s8
  in s6 `seq` (s7 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s8 `seq` (s3 `seq`
  (s4 `seq` C_Bin (Curry_Prelude.nd_C_aValue x1 s0 cd cs)
  (Curry_Prelude.nd_C_aValue x2 s1 cd cs)
  (Curry_Prelude.nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Prelude_dot_Int
  s2 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  x1 x2 s3 cd cs)
  (nd_OP_uscore_impl_hash_aValue_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
  x1 x2 s4 cd cs))))))))) s9 cd cs))

d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Map t1 t0)
d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Show
    (d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 cd cs) (acceptCs id
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2))
    (d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Show#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Show#Data.Map.Map"
    (showCons x3))

nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show (C_Map t1 t0)
nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Show
    (nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 s0 cd cs) (wrapDX (wrapNX id) (acceptCs id
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2)))
    (nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 s1 cd cs)))
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 l s
    cd cs) (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1
    x2 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Show#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Show#Data.Map.Map"
    (showCons x3))

d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover
  -> ConstStore -> C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  Curry_Prelude.C_Char
d_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2)

nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> IDSupply
  -> Cover -> ConstStore -> Func (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_show_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 s cd cs =
  wrapNX id (Curry_Prelude.nd_OP_uscore_def_hash_show_hash_Prelude_dot_Show
  (wrapNX id (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  x1 x2)))

d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> C_Map t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 cd cs =
  case x4 of
  C_Tip -> Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Tip")
  C_Bin x5 x6 x7 x8 x9 -> Curry_Prelude.d_C_showParen (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) (Curry_Prelude.C_Int (10)) cd cs) x3 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Bin "))
    (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showsPrec x1 cd cs) (Curry_Prelude.C_Int (11)) cd cs) x5
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString " ")) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_showsPrec x2 cd cs) (Curry_Prelude.C_Int (11)) cd cs) x6
    cd cs) (Curry_Prelude.d_OP_dot (Curry_Prelude.d_C_showString
    (Curry_Prelude.toCurryString " ")) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int
    cd cs) (Curry_Prelude.C_Int (11)) cd cs) x7 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (Curry_Prelude.d_OP_dot
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 (Curry_Prelude.C_Int (11)) x8 cd cs) (Curry_Prelude.d_OP_dot
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " "))
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 (Curry_Prelude.C_Int (11)) x9 cd cs) cd cs) cd cs) cd cs) cd cs) cd
    cs) cd cs) cd cs) cd cs) cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 l cd cs)
    (d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail
    "Data.Map._impl#showsPrec#Prelude.Show#Data.Map.Map" [show x1, show x2, show
    x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#showsPrec#Prelude.Show#Data.Map.Map" (showCons x4))

nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0)
  -> Curry_Prelude.C_Int -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)
nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 s cd cs =
  case x4 of
  C_Tip -> wrapDX id (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString
    "Tip"))
  C_Bin x5 x6 x7 x8 x9 -> let s41 = s
    in s41 `seq` (let s40 = leftSupply s41
                      s42 = rightSupply s41
                      s2 = leftSupply s42
                      s39 = rightSupply s42
    in s40 `seq` (s42 `seq` (s2 `seq` (s39 `seq` Curry_Prelude.nd_C_showParen
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs)) (Curry_Prelude.C_Int (10)) s0 cd cs) x3 s1 cd cs))
    (let s38 = leftSupply s39
         s36 = rightSupply s39
    in s38 `seq` (s36 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString "Bin ")))
    (let s35 = leftSupply s36
         s37 = rightSupply s36
         s7 = leftSupply s37
         s34 = rightSupply s37
    in s35 `seq` (s37 `seq` (s7 `seq` (s34 `seq` Curry_Prelude.nd_OP_dot
    (let s6 = leftSupply s7
         s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (let s4 = leftSupply s5
                                                        s3 = rightSupply s5
    in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_showsPrec
    x1 s3 cd cs) (Curry_Prelude.C_Int (11)) s4 cd cs)) x5 s6 cd cs))
    (let s33 = leftSupply s34
         s31 = rightSupply s34
    in s33 `seq` (s31 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (let s30 = leftSupply s31
         s32 = rightSupply s31
         s12 = leftSupply s32
         s29 = rightSupply s32
    in s30 `seq` (s32 `seq` (s12 `seq` (s29 `seq` Curry_Prelude.nd_OP_dot
    (let s11 = leftSupply s12
         s10 = rightSupply s12
    in s11 `seq` (s10 `seq` Curry_Prelude.nd_C_apply (let s9 = leftSupply s10
                                                          s8 = rightSupply s10
    in s9 `seq` (s8 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_showsPrec
    x2 s8 cd cs) (Curry_Prelude.C_Int (11)) s9 cd cs)) x6 s11 cd cs))
    (let s28 = leftSupply s29
         s26 = rightSupply s29
    in s28 `seq` (s26 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (let s25 = leftSupply s26
         s27 = rightSupply s26
         s15 = leftSupply s27
         s24 = rightSupply s27
    in s25 `seq` (s27 `seq` (s15 `seq` (s24 `seq` Curry_Prelude.nd_OP_dot
    (let s14 = leftSupply s15
         s13 = rightSupply s15
    in s14 `seq` (s13 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX (wrapDX id))
    (Curry_Prelude.d_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Prelude_dot_Int
    cd cs)) (Curry_Prelude.C_Int (11)) s13 cd cs) x7 s14 cd cs))
    (let s23 = leftSupply s24
         s21 = rightSupply s24
    in s23 `seq` (s21 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (let s20 = leftSupply s21
         s22 = rightSupply s21
         s16 = leftSupply s22
         s19 = rightSupply s22
    in s20 `seq` (s22 `seq` (s16 `seq` (s19 `seq` Curry_Prelude.nd_OP_dot
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 (Curry_Prelude.C_Int (11)) x8 s16 cd cs) (let s18 = leftSupply s19
                                                        s17 = rightSupply s19
    in s18 `seq` (s17 `seq` Curry_Prelude.nd_OP_dot (wrapDX id
    (Curry_Prelude.d_C_showString (Curry_Prelude.toCurryString " ")))
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 (Curry_Prelude.C_Int (11)) x9 s17 cd cs) s18 cd cs)) s20 cd cs)))) s23
    cd cs)) s25 cd cs)))) s28 cd cs)) s30 cd cs)))) s33 cd cs)) s35 cd cs))))
    s38 cd cs)) s40 cd cs))))
  Choice_C_Map d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 l s cd cs)
    (nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_showsPrec_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
    x1 x2 x3 e s cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail
    "Data.Map._impl#showsPrec#Prelude.Show#Data.Map.Map" [show x1, show x2, show
    x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#showsPrec#Prelude.Show#Data.Map.Map" (showCons x4))

d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (C_Map t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char
d_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (d_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2) cd cs

nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Show t0) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List (C_Map t1 t0)) (Func
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_showList_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_uscore_def_hash_showList_hash_Prelude_dot_Show
  (wrapNX id (nd_OP_uscore_inst_hash_Prelude_dot_Show_hash_Data_dot_Map_dot_Map
  x1 x2)) s0 cd cs

d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read (C_Map t1 t0)
d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 x3 cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> Curry_Prelude.OP_uscore_Dict_hash_Read (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x1 x2))
    (d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x1 x2 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 l cd
    cs) (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2
    r cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 z cd
    cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 e cd
    x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Read#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Read#Data.Map.Map"
    (showCons x3))

nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.OP_Unit -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read (C_Map t1 t0)
nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 x3 s cd cs =
  case x3 of
  Curry_Prelude.OP_Unit -> let s0 = s
    in s0 `seq` Curry_Prelude.HO_OP_uscore_Dict_hash_Read (wrapDX (wrapNX id)
    (acceptCs id
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x1 x2)))
    (nd_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x1 x2 s0 cd cs)
  Curry_Prelude.Choice_OP_Unit d i l r -> narrow d i
    (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 l s
    cd cs) (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1
    x2 r s cd cs)
  Curry_Prelude.Choices_OP_Unit d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 z s
    cd cs) xs
  Curry_Prelude.Guard_OP_Unit d c e -> guardCons d c ((\x ->
    nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 e s
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Unit d info -> failCons d (traceFail
    "Data.Map._inst#Prelude.Read#Data.Map.Map" [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._inst#Prelude.Read#Data.Map.Map"
    (showCons x3))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 cd cs =
  Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_readParen Curry_Prelude.C_False
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1
  cd cs) x4 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readParen
  (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
  cd cs) (Curry_Prelude.C_Int (10)) cd cs) x3 cd cs)
  (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6
  x2 x1) cd cs) x4 cd cs) cd cs

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.C_Int -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> IDSupply -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 x3 x4 s cd cs =
  let s10 = s
  in s10 `seq` (let s2 = leftSupply s10
                    s9 = rightSupply s10
  in s2 `seq` (s9 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                          s0 = rightSupply s2
  in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_readParen
  Curry_Prelude.C_False (wrapDX id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1)
  s0 cd cs) x4 s1 cd cs)) (let s8 = leftSupply s9
                               s7 = rightSupply s9
  in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                      s5 = rightSupply s7
  in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_readParen (let s4 = leftSupply s5
                                                          s3 = rightSupply s5
  in s4 `seq` (s3 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
  (wrapDX (wrapDX id)
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
  cd cs)) (Curry_Prelude.C_Int (10)) s3 cd cs) x3 s4 cd cs)) (wrapNX id
  (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6
  x2 x1)) s6 cd cs)) x4 s8 cd cs)) cd cs))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Curry_Prelude.OP_List
  Curry_Prelude.C_Char -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1 x1 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4)
  Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x1 cd cs) cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4 x1 x2 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple2 x3 x4 -> d_C__case_56 x3 x2 x4
    (Curry_Prelude.d_C_eqString x3 (Curry_Prelude.toCurryString "Tip") cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    l x2 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    r x2 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    z x2 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda1_dot_uscore_hash_lambda4
    e x2 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda1._#lambda4"
    [show x1, show x2] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda1._#lambda4"
    (showCons x1))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6 x1 x2 x3 cd cs =
  Curry_Prelude.d_C_foldr (acceptCs id
  (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
  x1 x2)) Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x3 cd cs) cd cs

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6 x1 x2 x3 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
  x1 x2))) Curry_Prelude.OP_List (Curry_Prelude.d_C_lex x3 cd cs) s0 cd cs

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 x1 x2 x3 x4 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C__case_55 x5 x4 x6 x2 x1
    (Curry_Prelude.d_C_eqString x5 (Curry_Prelude.toCurryString "Bin") cd cs) cd
    cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 r x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 z x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 e x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9"
    (showCons x3))

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9 x1 x2 x3 x4 s cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s0 = s
    in s0 `seq` nd_C__case_55 x5 x4 x6 x2 x1 (Curry_Prelude.d_C_eqString x5
    (Curry_Prelude.toCurryString "Bin") cd cs) s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 l x4 s cd cs)
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9"
    (showCons x3))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 x1 x2 x3 x4 cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x5 x1 x2)) Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readsPrec x1 cd cs)
    (Curry_Prelude.C_Int (11)) cd cs) x6 cd cs) cd cs) x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 l x4 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 r x4 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 z x4 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 e x4 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13"
    (showCons x3))

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 t1 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13 x1 x2 x3 x4 s cd cs =
  case x3 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s6 = s
    in s6 `seq` Curry_Prelude.d_OP_plus_plus (let s5 = leftSupply s6
                                                  s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
    id
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x5 x1 x2))) Curry_Prelude.OP_List (let s3 = leftSupply s4
                                           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_readsPrec
    x1 s0 cd cs) (Curry_Prelude.C_Int (11)) s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
    x4 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 l x4 s cd cs)
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 r x4 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 z x4 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2 e x4 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13"
    (showCons x3))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 cd cs =
  case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x6 x1 x2 x3)) Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Prelude_dot_Int
    (Curry_Prelude.C_Int (11)) cd cs) x7 cd cs) cd cs) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 l x5 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 r x5 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 z x5 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 e x5 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17"
    [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17"
    (showCons x4))

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 t0 (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17 x1 x2 x3 x4 x5 s cd cs =
  case x4 of
  Curry_Prelude.OP_Tuple2 x6 x7 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
    id
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x6 x1 x2 x3))) Curry_Prelude.OP_List (Curry_Prelude.nd_C_apply (wrapDX id
    (Curry_Prelude.d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Prelude_dot_Int
    (Curry_Prelude.C_Int (11)) cd cs)) x7 s0 cd cs) s1 cd cs)) x5 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 l x5 s cd cs)
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 r x5 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 z x5 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17
    x1 x2 x3 e x5 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17"
    [show x1, show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17"
    (showCons x4))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map
  t1 t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x7 x1 x2 x3 x4)) Curry_Prelude.OP_List
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x4 x3 (Curry_Prelude.C_Int (11)) x8 cd cs) cd cs) x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 l x6 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 r x6 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 z x6 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 e x6 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21"
    [show x1, show x2, show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21"
    (showCons x5))

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 Curry_Prelude.C_Int (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map
  t1 t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21 x1 x2 x3 x4 x5 x6 s cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
    id
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x7 x1 x2 x3 x4))) Curry_Prelude.OP_List
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x4 x3 (Curry_Prelude.C_Int (11)) x8 s0 cd cs) s1 cd cs)) x6 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 l x6 s cd cs)
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 r x6 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 z x6 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21
    x1 x2 x3 x4 e x6 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21"
    [show x1, show x2, show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21"
    (showCons x5))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.C_Int
  -> t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t1)
  -> Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char) -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map
  t1 t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char)) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 cd cs =
  case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> Curry_Prelude.d_OP_plus_plus
    (Curry_Prelude.d_C_foldr (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x8)) Curry_Prelude.OP_List
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x5 x4 (Curry_Prelude.C_Int (11)) x9 cd cs) cd cs) x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 l x7 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 r x7 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 z x7 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 e x7 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25"
    [show x1, show x2, show x3, show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25"
    (showCons x6))

nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.C_Int
  -> t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Curry_Prelude.OP_Tuple2 (C_Map
  t1 t0) (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25 x1 x2 x3 x4 x5 x6 x7 s cd cs =
  case x6 of
  Curry_Prelude.OP_Tuple2 x8 x9 -> let s2 = s
    in s2 `seq` Curry_Prelude.d_OP_plus_plus (let s1 = leftSupply s2
                                                  s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapDX id) (acceptCs
    id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x8))) Curry_Prelude.OP_List
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
    x5 x4 (Curry_Prelude.C_Int (11)) x9 s0 cd cs) s1 cd cs)) x7 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 l x7 s cd cs)
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 r x7 s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 z x7 s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25
    x1 x2 x3 x4 x5 e x7 s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25"
    [show x1, show x2, show x3, show x4, show x5, show x6, show x7] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25"
    (showCons x6))

d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => Curry_Prelude.C_Int
  -> t0 -> t1 -> C_Map t1 t0 -> Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29 x1 x2 x3 x4 x5 x6 cd cs =
  case x5 of
  Curry_Prelude.OP_Tuple2 x7 x8 -> Curry_Prelude.OP_Cons
    (Curry_Prelude.OP_Tuple2 (C_Bin x3 x2 x1 x4 x7) x8) x6
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x4 l x6 cd cs)
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x4 r x6 cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x4 z x6 cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13_dot_uscore_hash_lambda17_dot_uscore_hash_lambda21_dot_uscore_hash_lambda25_dot_uscore_hash_lambda29
    x1 x2 x3 x4 e x6 cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25._#lambda29"
    [show x1, show x2, show x3, show x4, show x5, show x6] info)
  _ -> failCons cd (consFail
    "Data.Map._impl#readsPrec#Prelude.Read#Data.Map.Map._#lambda6._#lambda9._#lambda13._#lambda17._#lambda21._#lambda25._#lambda29"
    (showCons x5))

d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> Cover
  -> ConstStore -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Cover
  -> ConstStore -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2
  (Curry_Prelude.OP_List (C_Map t1 t0)) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 cd cs =
  Curry_Prelude.d_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  (d_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2) cd cs

nd_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0) -> IDSupply
  -> Cover -> ConstStore -> Func (Curry_Prelude.OP_List Curry_Prelude.C_Char)
  (Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (Curry_Prelude.OP_List (C_Map
  t1 t0)) (Curry_Prelude.OP_List Curry_Prelude.C_Char)))
nd_OP_uscore_impl_hash_readList_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map x1 x2 s cd cs =
  let s0 = s
  in s0 `seq` Curry_Prelude.nd_OP_uscore_def_hash_readList_hash_Prelude_dot_Read
  (wrapNX id (nd_OP_uscore_inst_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map
  x1 x2)) s0 cd cs

d_C_empty :: Cover -> ConstStore -> forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_Map t1 t0
d_C_empty cd cs = C_Tip

d_C_singleton :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_singleton x1 x2 cd cs = C_Bin x1 x2 (Curry_Prelude.C_Int (1)) C_Tip C_Tip

d_C_fromList :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore -> C_Map t1 t0
d_C_fromList x1 x2 cd cs = d_C_insertList x1 x2 (d_C_empty cd cs) cd cs

nd_C_fromList :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> IDSupply -> Cover
  -> ConstStore -> C_Map t1 t0
nd_C_fromList x1 x2 s cd cs = let s0 = s
  in s0 `seq` nd_C_insertList x1 x2 (d_C_empty cd cs) s0 cd cs

d_C_insert :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> t0 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t0
d_C_insert x1 x2 x3 x4 cd cs = d_C_insertWith x1 (acceptCs id
  d_OP_insert_dot_uscore_hash_lambda31) x2 x3 x4 cd cs

nd_C_insert :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> t0 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C_insert x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` nd_C_insertWith x1 (wrapDX (wrapDX id) (acceptCs id
  d_OP_insert_dot_uscore_hash_lambda31)) x2 x3 x4 s0 cd cs

d_OP_insert_dot_uscore_hash_lambda31 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> t0 -> Cover -> ConstStore -> t0
d_OP_insert_dot_uscore_hash_lambda31 x1 x2 cd cs = x2

d_C_insertWith :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> t0) -> t1 -> t0 -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_insertWith x1 x2 x3 x4 x5 cd cs = case x5 of
  C_Tip -> d_C_singleton x3 x4 cd cs
  C_Bin x6 x7 x8 x9 x10 -> d_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1
    cd cs) x3 cd cs) x6 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_insertWith x1 x2 x3 x4 l cd cs)
    (d_C_insertWith x1 x2 x3 x4 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_insertWith x1 x2 x3 x4 z cd
    cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_insertWith x1 x2 x3 x4 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.insertWith" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.Map.insertWith" (showCons x5))

nd_C_insertWith :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Func t0 (Func t0 t0) -> t1 -> t0 -> C_Map t1 t0 -> IDSupply -> Cover
  -> ConstStore -> C_Map t1 t0
nd_C_insertWith x1 x2 x3 x4 x5 s cd cs = case x5 of
  C_Tip -> d_C_singleton x3 x4 cd cs
  C_Bin x6 x7 x8 x9 x10 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x3 s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_insertWith x1 x2 x3 x4 l s cd cs)
    (nd_C_insertWith x1 x2 x3 x4 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_insertWith x1 x2 x3 x4 z s
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_insertWith x1 x2 x3 x4 e s cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.insertWith" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.Map.insertWith" (showCons x5))

d_C_insertList :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C_insertList x1 x2 x3 cd cs = d_C_insertListWith x1 (acceptCs id
  d_OP_insertList_dot_uscore_hash_lambda32) x2 x3 cd cs

nd_C_insertList :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0) -> C_Map t1 t0
  -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C_insertList x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_insertListWith x1 (wrapDX (wrapDX id) (acceptCs id
  d_OP_insertList_dot_uscore_hash_lambda32)) x2 x3 s0 cd cs

d_OP_insertList_dot_uscore_hash_lambda32 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> t0 -> Cover -> ConstStore -> t0
d_OP_insertList_dot_uscore_hash_lambda32 x1 x2 cd cs = x2

d_C_insertListWith :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> (t1 -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> t1) -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t0 t1) -> C_Map t0 t1 -> Cover -> ConstStore -> C_Map
  t0 t1
d_C_insertListWith x1 x2 x3 x4 cd cs = Curry_Prelude.d_C_foldl (acceptCs id
  (d_OP_insertListWith_dot_add_dot_21 x2 x1)) x4 x3 cd cs

nd_C_insertListWith :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Func t1 (Func t1 t1)
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t0 t1) -> C_Map t0 t1
  -> IDSupply -> Cover -> ConstStore -> C_Map t0 t1
nd_C_insertListWith x1 x2 x3 x4 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldl (wrapDX (wrapNX id) (acceptCs id
  (nd_OP_insertListWith_dot_add_dot_21 x2 x1))) x4 x3 s0 cd cs

d_OP_insertListWith_dot_add_dot_21 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => (t0 -> Cover -> ConstStore -> t0 -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_OP_insertListWith_dot_add_dot_21 x1 x2 x3 x4 cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> d_C_insertWith x2 x1 x5 x6 x3 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_insertListWith_dot_add_dot_21 x1 x2 x3 l cd cs)
    (d_OP_insertListWith_dot_add_dot_21 x1 x2 x3 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_insertListWith_dot_add_dot_21 x1 x2 x3 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_insertListWith_dot_add_dot_21 x1 x2 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.insertListWith.add.21" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.insertListWith.add.21" (showCons x4))

nd_OP_insertListWith_dot_add_dot_21 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => Func t0 (Func t0 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1
  t0 -> Curry_Prelude.OP_Tuple2 t1 t0 -> IDSupply -> Cover -> ConstStore
  -> C_Map t1 t0
nd_OP_insertListWith_dot_add_dot_21 x1 x2 x3 x4 s cd cs = case x4 of
  Curry_Prelude.OP_Tuple2 x5 x6 -> let s0 = s
    in s0 `seq` nd_C_insertWith x2 x1 x5 x6 x3 s0 cd cs
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (nd_OP_insertListWith_dot_add_dot_21 x1 x2 x3 l s cd cs)
    (nd_OP_insertListWith_dot_add_dot_21 x1 x2 x3 r s cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    nd_OP_insertListWith_dot_add_dot_21 x1 x2 x3 z s cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    nd_OP_insertListWith_dot_add_dot_21 x1 x2 x3 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.insertListWith.add.21" [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.insertListWith.add.21" (showCons x4))

d_C_delete :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_delete x1 x2 x3 cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_52 x4 x2 x1 x8 x7 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1
    cd cs) x2 cd cs) x4 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_delete x1 x2 l cd cs) (d_C_delete x1
    x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_delete x1 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_delete x1 x2 e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.delete" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.delete" (showCons x3))

nd_C_delete :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C_delete x1 x2 x3 s cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_52 x4 x2 x1 x8 x7 x5 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x2 s1 cd cs)) x4 s3 cd cs)) s5 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_delete x1 x2 l s cd cs) (nd_C_delete
    x1 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_delete x1 x2 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_delete x1 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.delete" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.delete" (showCons x3))

d_C_deleteAll :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> Curry_Prelude.OP_List t1
  -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_deleteAll x1 x2 x3 cd cs = Curry_Prelude.d_C_foldl (acceptCs id
  (Curry_Prelude.d_C_flip (acceptCs id (d_C_delete x1)))) x3 x2 cd cs

nd_C_deleteAll :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Curry_Prelude.OP_List t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> C_Map t1 t0
nd_C_deleteAll x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Curry_Prelude.nd_C_foldl (wrapDX (wrapNX id) (acceptCs id
  (Curry_Prelude.nd_C_flip (wrapDX (wrapNX id) (acceptCs id (nd_C_delete
  x1)))))) x3 x2 s0 cd cs

d_C_adjust :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> (t0 -> Cover -> ConstStore
  -> t0) -> t1 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_adjust x1 x2 x3 x4 cd cs = case x4 of
  C_Tip -> C_Tip
  C_Bin x5 x6 x7 x8 x9 -> d_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x3 cd cs) x5 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_adjust x1 x2 x3 l cd cs) (d_C_adjust
    x1 x2 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_adjust x1 x2 x3 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_adjust x1 x2 x3 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.adjust" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.adjust" (showCons x4))

nd_C_adjust :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Func t0 t0 -> t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map
  t1 t0
nd_C_adjust x1 x2 x3 x4 s cd cs = case x4 of
  C_Tip -> C_Tip
  C_Bin x5 x6 x7 x8 x9 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x3 s3 cd cs)) x5 s5 cd cs)) s7 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_adjust x1 x2 x3 l s cd cs)
    (nd_C_adjust x1 x2 x3 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_adjust x1 x2 x3 z s cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_adjust x1 x2 x3 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.adjust" [show x1, show x2
    , show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.adjust" (showCons x4))

d_C_splitLookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> C_Map t1 t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe
  t0) (C_Map t1 t0)
d_C_splitLookup x1 x2 x3 cd cs = case x3 of
  C_Tip -> Curry_Prelude.OP_Tuple3 C_Tip Curry_Prelude.C_Nothing C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_47 x4 x2 x1 x8 x7 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x2 cd cs) x4 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_splitLookup x1 x2 l cd cs)
    (d_C_splitLookup x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_splitLookup x1 x2 z cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_splitLookup x1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitLookup" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup" (showCons x3))

nd_C_splitLookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1
  t0)
nd_C_splitLookup x1 x2 x3 s cd cs = case x3 of
  C_Tip -> Curry_Prelude.OP_Tuple3 C_Tip Curry_Prelude.C_Nothing C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_47 x4 x2 x1 x8 x7 x5 (let s5 = leftSupply
                                                                 s6
                                                               s4 = rightSupply
                                                                 s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x2 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_splitLookup x1 x2 l s cd cs)
    (nd_C_splitLookup x1 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_splitLookup x1 x2 z s cd
    cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_splitLookup x1 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitLookup" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup" (showCons x3))

d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> C_Map t1 t0
d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP2#m_l'" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP2#m_l'" (showCons x1))

d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP3#v" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP3#v" (showCons x1))

d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> C_Map t1 t0
d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP4#m_r'" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP4#m_r'" (showCons x1))

d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> C_Map t1 t0
d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x2
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP6#m_l'" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP6#m_l'" (showCons x1))

d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x3
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v e cd x) $! addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP7#v" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP7#v" (showCons x1))

d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map
  t1 t0) -> Cover -> ConstStore -> C_Map t1 t0
d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick x1 cd cs =
  case x1 of
  Curry_Prelude.OP_Tuple3 x2 x3 x4 -> x4
  Curry_Prelude.Choice_OP_Tuple3 d i l r -> narrow d i
    (d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick l cd cs)
    (d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick r cd cs)
  Curry_Prelude.Choices_OP_Tuple3 d i xs -> narrows cs d i (\z ->
    d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple3 d c e -> guardCons d c ((\x ->
    d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick e cd x) $!
    addCs c cs)
  Curry_Prelude.Fail_OP_Tuple3 d info -> failCons d (traceFail
    "Data.Map.splitLookup._#selFP8#m_r'" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.splitLookup._#selFP8#m_r'" (showCons x1))

d_C_union :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t0
d_C_union x1 x2 x3 cd cs = case x2 of
  C_Tip -> x3
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_44 x4 x1 x8 x7 x5 x2 x3 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_union x1 l x3 cd cs) (d_C_union x1 r
    x3 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_union x1 z x3 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_union x1 e x3 cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.union" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.union" (showCons x2))

nd_C_union :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1
  t0
nd_C_union x1 x2 x3 s cd cs = case x2 of
  C_Tip -> x3
  C_Bin x4 x5 x6 x7 x8 -> let s0 = s
    in s0 `seq` nd_C__case_44 x4 x1 x8 x7 x5 x2 x3 s0 cd cs
  Choice_C_Map d i l r -> narrow d i (nd_C_union x1 l x3 s cd cs) (nd_C_union x1
    r x3 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_union x1 z x3 s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_union x1 e x3 s cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.union" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.union" (showCons x2))

d_C_unionWith :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> (t0 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> t0) -> C_Map t1 t0 -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_unionWith x1 x2 x3 x4 cd cs = case x3 of
  C_Tip -> x4
  C_Bin x5 x6 x7 x8 x9 -> d_C__case_43 x5 x1 x6 x2 x9 x8 x3 x4 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_unionWith x1 x2 l x4 cd cs)
    (d_C_unionWith x1 x2 r x4 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_unionWith x1 x2 z x4 cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_unionWith x1 x2 e x4 cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.unionWith" [show x1, show
    x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.unionWith" (showCons x3))

nd_C_unionWith :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> Func t0 (Func t0 t0) -> C_Map t1 t0 -> C_Map t1 t0 -> IDSupply -> Cover
  -> ConstStore -> C_Map t1 t0
nd_C_unionWith x1 x2 x3 x4 s cd cs = case x3 of
  C_Tip -> x4
  C_Bin x5 x6 x7 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_43 x5 x1 x6 x2 x9 x8 x3 x4 s0 cd cs
  Choice_C_Map d i l r -> narrow d i (nd_C_unionWith x1 x2 l x4 s cd cs)
    (nd_C_unionWith x1 x2 r x4 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_unionWith x1 x2 z x4 s cd
    cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_unionWith x1 x2 e x4 s cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.unionWith" [show x1, show
    x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.unionWith" (showCons x3))

d_C_difference :: forall t0 t1 t2 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t2 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t2
d_C_difference x1 x2 x3 cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_41 x2 x1 x3 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_difference x1 l x3 cd cs)
    (d_C_difference x1 r x3 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_difference x1 z x3 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_difference x1 e x3 cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.difference" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.difference" (showCons x2))

nd_C_difference :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1
  t2 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t2
nd_C_difference x1 x2 x3 s cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s0 = s in s0 `seq` nd_C__case_41 x2 x1 x3 s0 cd cs
  Choice_C_Map d i l r -> narrow d i (nd_C_difference x1 l x3 s cd cs)
    (nd_C_difference x1 r x3 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_difference x1 z x3 s cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_difference x1 e x3 s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.difference" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.difference" (showCons x2))

d_C_intersection :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t0
d_C_intersection x1 x2 x3 cd cs = d_C_intersectionWith x1 (acceptCs id
  d_OP_intersection_dot_uscore_hash_lambda34) x2 x3 cd cs

nd_C_intersection :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1
  t0
nd_C_intersection x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` nd_C_intersectionWith x1 (wrapDX (wrapDX id) (acceptCs id
  d_OP_intersection_dot_uscore_hash_lambda34)) x2 x3 s0 cd cs

d_OP_intersection_dot_uscore_hash_lambda34 :: forall t0 . (Curry_Prelude.Curry
  t0) => t0 -> t0 -> Cover -> ConstStore -> t0
d_OP_intersection_dot_uscore_hash_lambda34 x1 x2 cd cs = x1

d_C_intersectionWith :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> (t3 -> Cover -> ConstStore
  -> t1 -> Cover -> ConstStore -> t0) -> C_Map t2 t3 -> C_Map t2 t1 -> Cover
  -> ConstStore -> C_Map t2 t0
d_C_intersectionWith x1 x2 x3 x4 cd cs = case x4 of
  C_Tip -> C_Tip
  C_Bin x5 x6 x7 x8 x9 -> d_C__case_40 x5 x1 x9 x2 x8 x6 x3 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_intersectionWith x1 x2 x3 l cd cs)
    (d_C_intersectionWith x1 x2 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_intersectionWith x1 x2 x3 z
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_intersectionWith x1 x2 x3 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.intersectionWith" [show
    x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.intersectionWith" (showCons x4))

nd_C_intersectionWith :: forall t0 t1 t2 t3 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t3, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t2)
  -> Func t3 (Func t1 t0) -> C_Map t2 t3 -> C_Map t2 t1 -> IDSupply -> Cover
  -> ConstStore -> C_Map t2 t0
nd_C_intersectionWith x1 x2 x3 x4 s cd cs = case x4 of
  C_Tip -> C_Tip
  C_Bin x5 x6 x7 x8 x9 -> let s0 = s
    in s0 `seq` nd_C__case_40 x5 x1 x9 x2 x8 x6 x3 s0 cd cs
  Choice_C_Map d i l r -> narrow d i (nd_C_intersectionWith x1 x2 x3 l s cd cs)
    (nd_C_intersectionWith x1 x2 x3 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_intersectionWith x1 x2 x3 z
    s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_intersectionWith x1 x2 x3 e s
    cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.intersectionWith" [show
    x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.intersectionWith" (showCons x4))

d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick :: forall t0 . (Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Maybe t0 -> Cover -> ConstStore -> t0
d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick x1 cd cs = case x1 of
  Curry_Prelude.C_Just x2 -> x2
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i
    (d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick l cd cs)
    (d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z ->
    d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x ->
    d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick e cd x) $! addCs
    c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail
    "Data.Map.intersectionWith._#selFP10#a1'" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.intersectionWith._#selFP10#a1'" (showCons
    x1))

d_C_foldrWithKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t2) => (t1 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t2 -> Cover -> ConstStore -> t2)
  -> t2 -> C_Map t1 t0 -> Cover -> ConstStore -> t2
d_C_foldrWithKey x1 x2 x3 cd cs = case x3 of
  C_Tip -> x2
  C_Bin x4 x5 x6 x7 x8 -> d_C_foldrWithKey x1 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x1 x4 cd cs) x5 cd cs)
    (d_C_foldrWithKey x1 x2 x8 cd cs) cd cs) x7 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_foldrWithKey x1 x2 l cd cs)
    (d_C_foldrWithKey x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_foldrWithKey x1 x2 z cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_foldrWithKey x1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.foldrWithKey" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.foldrWithKey" (showCons x3))

nd_C_foldrWithKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0, Curry_Prelude.Curry t2) => Func t1 (Func t0 (Func t2
  t2)) -> t2 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> t2
nd_C_foldrWithKey x1 x2 x3 s cd cs = case x3 of
  C_Tip -> x2
  C_Bin x4 x5 x6 x7 x8 -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s5 = rightSupply s8
    in s7 `seq` (s5 `seq` nd_C_foldrWithKey x1 (let s4 = leftSupply s5
                                                    s6 = rightSupply s5
                                                    s2 = leftSupply s6
                                                    s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` Curry_Prelude.nd_C_apply
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x4 s0 cd cs) x5 s1 cd cs)) (nd_C_foldrWithKey x1 x2 x8 s3 cd cs) s4 cd
    cs)))) x7 s7 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_foldrWithKey x1 x2 l s cd cs)
    (nd_C_foldrWithKey x1 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_foldrWithKey x1 x2 z s cd
    cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_foldrWithKey x1 x2 e s cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.foldrWithKey" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.foldrWithKey" (showCons x3))

d_C_mapWithKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t2, Curry_Prelude.Curry
  t1, Curry_Prelude.Curry t0) => (t2 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> C_Map t2 t1 -> Cover -> ConstStore -> C_Map t2 t0
d_C_mapWithKey x1 x2 cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x3 x4 x5 x6 x7 -> C_Bin x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x1 x3 cd cs) x4 cd cs) x5 (d_C_mapWithKey x1 x6 cd
    cs) (d_C_mapWithKey x1 x7 cd cs)
  Choice_C_Map d i l r -> narrow d i (d_C_mapWithKey x1 l cd cs) (d_C_mapWithKey
    x1 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_mapWithKey x1 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_mapWithKey x1 e cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mapWithKey" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Data.Map.mapWithKey" (showCons x2))

nd_C_mapWithKey :: forall t0 t1 t2 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => Func t2 (Func t1 t0)
  -> C_Map t2 t1 -> IDSupply -> Cover -> ConstStore -> C_Map t2 t0
nd_C_mapWithKey x1 x2 s cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x3 x4 x5 x6 x7 -> let s5 = s
    in s5 `seq` (let s2 = leftSupply s5
                     s6 = rightSupply s5
                     s3 = leftSupply s6
                     s4 = rightSupply s6
    in s2 `seq` (s6 `seq` (s3 `seq` (s4 `seq` C_Bin x3 (let s1 = leftSupply s2
                                                            s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x1
    x3 s0 cd cs) x4 s1 cd cs)) x5 (nd_C_mapWithKey x1 x6 s3 cd cs)
    (nd_C_mapWithKey x1 x7 s4 cd cs)))))
  Choice_C_Map d i l r -> narrow d i (nd_C_mapWithKey x1 l s cd cs)
    (nd_C_mapWithKey x1 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_mapWithKey x1 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_mapWithKey x1 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mapWithKey" [show x1
    , show x2] info)
  _ -> failCons cd (consFail "Data.Map.mapWithKey" (showCons x2))

d_C_filterWithKey :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> (t1 -> Cover -> ConstStore
  -> t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool) -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_filterWithKey x1 x2 x3 cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_37 x5 x4 x2 x8 x1 x7
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply x2 x4 cd cs) x5 cd cs) cd
    cs
  Choice_C_Map d i l r -> narrow d i (d_C_filterWithKey x1 x2 l cd cs)
    (d_C_filterWithKey x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_filterWithKey x1 x2 z cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_filterWithKey x1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.filterWithKey" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.filterWithKey" (showCons x3))

nd_C_filterWithKey :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> Func t1 (Func t0
  Curry_Prelude.C_Bool) -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> C_Map t1 t0
nd_C_filterWithKey x1 x2 x3 s cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_37 x5 x4 x2 x8 x1 x7 (let s1 = leftSupply
                                                                 s2
                                                               s0 = rightSupply
                                                                 s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x4 s0 cd cs) x5 s1 cd cs)) s3 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_filterWithKey x1 x2 l s cd cs)
    (nd_C_filterWithKey x1 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_filterWithKey x1 x2 z s cd
    cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_filterWithKey x1 x2 e s cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.filterWithKey" [show x1
    , show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.filterWithKey" (showCons x3))

d_C_size :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_size x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.C_Int (0)
  C_Bin x2 x3 x4 x5 x6 -> x4
  Choice_C_Map d i l r -> narrow d i (d_C_size l cd cs) (d_C_size r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_size z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_size e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.size" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.size" (showCons x1))

d_C_null :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_null x1 cd cs =
  Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_hash_Prelude_dot_Eq_hash_Prelude_dot_Int
  (d_C_size x1 cd cs) (Curry_Prelude.C_Int (0)) cd cs

d_C_member :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> C_Map t1 t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
d_C_member x1 x2 x3 cd cs = Data.Curry_Maybe.d_C_isJust (d_C_lookup x1 x2 x3 cd
  cs) cd cs

nd_C_member :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
nd_C_member x1 x2 x3 s cd cs = let s0 = s
  in s0 `seq` Data.Curry_Maybe.d_C_isJust (nd_C_lookup x1 x2 x3 s0 cd cs) cd cs

d_C_lookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> C_Map t1 t0 -> Cover
  -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C_lookup x1 x2 x3 cd cs = case x3 of
  C_Tip -> Curry_Prelude.C_Nothing
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_35 x4 x2 x1 x8 x5 x7
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1
    cd cs) x2 cd cs) x4 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_lookup x1 x2 l cd cs) (d_C_lookup x1
    x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_lookup x1 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_lookup x1 x2 e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.lookup" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.lookup" (showCons x3))

nd_C_lookup :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
nd_C_lookup x1 x2 x3 s cd cs = case x3 of
  C_Tip -> Curry_Prelude.C_Nothing
  C_Bin x4 x5 x6 x7 x8 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_35 x4 x2 x1 x8 x5 x7 (let s3 = leftSupply
                                                                 s4
                                                               s2 = rightSupply
                                                                 s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x2 s1 cd cs)) x4 s3 cd cs)) s5 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_lookup x1 x2 l s cd cs) (nd_C_lookup
    x1 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_lookup x1 x2 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_lookup x1 x2 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.lookup" [show x1, show x2
    , show x3] info)
  _ -> failCons cd (consFail "Data.Map.lookup" (showCons x3))

d_C_findWithDefault :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> t1 -> C_Map t1 t0
  -> Cover -> ConstStore -> t0
d_C_findWithDefault x1 x2 x3 x4 cd cs = d_C__case_33 x4 x3 x1 x2 (d_C_lookup x1
  x3 x4 cd cs) cd cs

nd_C_findWithDefault :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> t1 -> C_Map t1 t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C_findWithDefault x1 x2 x3 x4 s cd cs = let s2 = s
  in s2 `seq` (let s1 = leftSupply s2
                   s0 = rightSupply s2
  in s1 `seq` (s0 `seq` nd_C__case_33 x4 x3 x1 x2 (nd_C_lookup x1 x3 x4 s0 cd
  cs) s1 cd cs))

d_C_lookupMin :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_lookupMin x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.C_Nothing
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_32 x5 x3 x2 (d_C_isBranch x5 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_lookupMin l cd cs) (d_C_lookupMin r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_lookupMin z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_lookupMin e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.lookupMin" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Map.lookupMin" (showCons x1))

d_C_lookupMax :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Maybe
  (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_lookupMax x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.C_Nothing
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_30 x6 x3 x2 (d_C_isBranch x6 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_lookupMax l cd cs) (d_C_lookupMax r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_lookupMax z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_lookupMax e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.lookupMax" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Map.lookupMax" (showCons x1))

d_C_toList :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_toList x1 cd cs = d_C_foldrWithKey (acceptCs (acceptCs id)
  d_OP_toList_dot_uscore_hash_lambda36) Curry_Prelude.OP_List x1 cd cs

d_OP_toList_dot_uscore_hash_lambda36 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_toList_dot_uscore_hash_lambda36 x1 x2 x3 cd cs = Curry_Prelude.OP_Cons
  (Curry_Prelude.OP_Tuple2 x1 x2) x3

d_C_keys :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => C_Map t0 t1 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_keys x1 cd cs = d_C_foldrWithKey (acceptCs (acceptCs id)
  d_OP_keys_dot_uscore_hash_lambda37) Curry_Prelude.OP_List x1 cd cs

d_OP_keys_dot_uscore_hash_lambda37 :: forall t0 t1 . (Curry_Prelude.Curry t0
  , Curry_Prelude.Curry t1) => t0 -> t1 -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_keys_dot_uscore_hash_lambda37 x1 x2 x3 cd cs = Curry_Prelude.OP_Cons x1 x3

d_C_elems :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_elems x1 cd cs = d_C_foldrWithKey (acceptCs (acceptCs id)
  d_OP_elems_dot_uscore_hash_lambda38) Curry_Prelude.OP_List x1 cd cs

d_OP_elems_dot_uscore_hash_lambda38 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => t1 -> t0 -> Curry_Prelude.OP_List t0 -> Cover
  -> ConstStore -> Curry_Prelude.OP_List t0
d_OP_elems_dot_uscore_hash_lambda38 x1 x2 x3 cd cs = Curry_Prelude.OP_Cons x2 x3

d_C_toPreOrderList :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_C_toPreOrderList x1 cd cs = d_OP_toPreOrderList_dot_pre_dot_207 x1
  Curry_Prelude.OP_List cd cs

d_OP_toPreOrderList_dot_pre_dot_207 :: forall t0 t1 . (Curry_Prelude.Curry t1
  , Curry_Prelude.Curry t0) => C_Map t1 t0 -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 t1 t0) -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 t1 t0)
d_OP_toPreOrderList_dot_pre_dot_207 x1 x2 cd cs = case x1 of
  C_Tip -> x2
  C_Bin x3 x4 x5 x6 x7 -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 x3 x4)
    (d_OP_toPreOrderList_dot_pre_dot_207 x6 (d_OP_toPreOrderList_dot_pre_dot_207
    x7 x2 cd cs) cd cs)
  Choice_C_Map d i l r -> narrow d i (d_OP_toPreOrderList_dot_pre_dot_207 l x2
    cd cs) (d_OP_toPreOrderList_dot_pre_dot_207 r x2 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_toPreOrderList_dot_pre_dot_207 z x2 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_OP_toPreOrderList_dot_pre_dot_207
    e x2 cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.toPreOrderList.pre.207"
    [show x1, show x2] info)
  _ -> failCons cd (consFail "Data.Map.toPreOrderList.pre.207" (showCons x1))

d_C_sortWithMap :: forall t0 . (Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t0) -> Curry_Prelude.OP_List t0
  -> Cover -> ConstStore -> Curry_Prelude.OP_List t0
d_C_sortWithMap x1 x2 cd cs = d_C_keys (d_C_fromList x1 (Curry_Prelude.d_C_zip
  x2 (Curry_Prelude.d_C_repeat Curry_Prelude.OP_Unit cd cs) cd cs) cd cs) cd cs

nd_C_sortWithMap :: forall t0 . (Curry_Prelude.Curry t0) => Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t0)
  -> Curry_Prelude.OP_List t0 -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List t0
nd_C_sortWithMap x1 x2 s cd cs = let s0 = s
  in s0 `seq` d_C_keys (nd_C_fromList x1 (Curry_Prelude.d_C_zip x2
  (Curry_Prelude.d_C_repeat Curry_Prelude.OP_Unit cd cs) cd cs) s0 cd cs) cd cs

d_C_isBranch :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C_isBranch x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> Curry_Prelude.C_True
  C_Tip -> Curry_Prelude.C_False
  Choice_C_Map d i l r -> narrow d i (d_C_isBranch l cd cs) (d_C_isBranch r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_isBranch z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_isBranch e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.isBranch" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.isBranch" (showCons x1))

d_C_sIZE_RATIO :: Cover -> ConstStore -> Curry_Prelude.C_Int
d_C_sIZE_RATIO cd cs = Curry_Prelude.C_Int (5)

d_C_mkBranch :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> t1 -> t0 -> C_Map t1 t0 -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_mkBranch x1 x2 x3 x4 x5 cd cs = let x6 = d_C_size x4 cd cs
                                        x7 = d_C_size x5 cd cs
  in C_Bin x2 x3 (d_OP_mkBranch_dot_unbox_dot_228
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
  (Curry_Prelude.C_Int (1)) x6 cd cs) x7 cd cs) cd cs) x4 x5

d_OP_mkBranch_dot_unbox_dot_228 :: Curry_Prelude.C_Int -> Cover -> ConstStore
  -> Curry_Prelude.C_Int
d_OP_mkBranch_dot_unbox_dot_228 x1 cd cs = x1

d_C_mkBalBranch :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t0 -> C_Map t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C_mkBalBranch x1 x2 x3 x4 cd cs = let x5 = d_C_size x3 cd cs
                                        x6 = d_C_size x4 cd cs
  in d_C__case_28 x6 x5 x4 x3 x2 x1 (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_C_apply
  (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
  cd cs)
  (Curry_Prelude.d_OP_uscore_impl_hash_plus_hash_Prelude_dot_Num_hash_Prelude_dot_Int
  x5 x6 cd cs) cd cs) (Curry_Prelude.C_Int (2)) cd cs) cd cs

d_OP_mkBalBranch_dot_single_uscore_L_dot_236 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> C_Map t1
  t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x1 x2 x3 x4 cd cs = case x4 of
  C_Bin x5 x6 x7 x8 x9 -> d_C_mkBranch (Curry_Prelude.C_Int (3)) x5 x6
    (d_C_mkBranch (Curry_Prelude.C_Int (4)) x2 x1 x3 x8 cd cs) x9 cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.single_L") cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x1 x2 x3 l cd cs)
    (d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x1 x2 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x1 x2 x3 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x1 x2 x3 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkBalBranch.single_L.236"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.mkBalBranch.single_L.236" (showCons x4))

d_OP_mkBalBranch_dot_double_uscore_L_dot_236 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> C_Map t1
  t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x1 x2 x3 x4 cd cs = case x4 of
  C_Bin x5 x6 x7 x8 x9 -> d_C__case_20 x9 x6 x5 x3 x1 x2 x8 cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.double_L") cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x1 x2 x3 l cd cs)
    (d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x1 x2 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x1 x2 x3 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x1 x2 x3 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkBalBranch.double_L.236"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.mkBalBranch.double_L.236" (showCons x4))

d_OP_mkBalBranch_dot_single_uscore_R_dot_236 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> C_Map t1
  t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x1 x2 x3 x4 cd cs = case x3 of
  C_Bin x5 x6 x7 x8 x9 -> d_C_mkBranch (Curry_Prelude.C_Int (8)) x5 x6 x8
    (d_C_mkBranch (Curry_Prelude.C_Int (9)) x2 x1 x9 x4 cd cs) cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.single_R") cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x1 x2 l x4 cd cs)
    (d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x1 x2 r x4 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x1 x2 z x4 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x1 x2 e x4 cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkBalBranch.single_R.236"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.mkBalBranch.single_R.236" (showCons x3))

d_OP_mkBalBranch_dot_double_uscore_R_dot_236 :: forall t0
  t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry t1) => t0 -> t1 -> C_Map t1
  t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x1 x2 x3 x4 cd cs = case x3 of
  C_Bin x5 x6 x7 x8 x9 -> d_C__case_19 x4 x1 x2 x8 x6 x5 x9 cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.double_R") cd cs
  Choice_C_Map d i l r -> narrow d i
    (d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x1 x2 l x4 cd cs)
    (d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x1 x2 r x4 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x1 x2 z x4 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x1 x2 e x4 cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkBalBranch.double_R.236"
    [show x1, show x2, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map.mkBalBranch.double_R.236" (showCons x3))

d_C_mkVBalBranch :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t1 -> t0 -> C_Map t1 t0
  -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_mkVBalBranch x1 x2 x3 x4 x5 cd cs = case x4 of
  C_Tip -> d_C_insert x1 x2 x3 x5 cd cs
  C_Bin x6 x7 x8 x9 x10 -> d_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 x5 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_mkVBalBranch x1 x2 x3 l x5 cd cs)
    (d_C_mkVBalBranch x1 x2 x3 r x5 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_mkVBalBranch x1 x2 x3 z x5
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_mkVBalBranch x1 x2 x3 e x5 cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkVBalBranch" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.Map.mkVBalBranch" (showCons x4))

nd_C_mkVBalBranch :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> t1 -> t0 -> C_Map t1 t0 -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore
  -> C_Map t1 t0
nd_C_mkVBalBranch x1 x2 x3 x4 x5 s cd cs = case x4 of
  C_Tip -> let s0 = s in s0 `seq` nd_C_insert x1 x2 x3 x5 s0 cd cs
  C_Bin x6 x7 x8 x9 x10 -> let s0 = s
    in s0 `seq` nd_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 x5 s0 cd cs
  Choice_C_Map d i l r -> narrow d i (nd_C_mkVBalBranch x1 x2 x3 l x5 s cd cs)
    (nd_C_mkVBalBranch x1 x2 x3 r x5 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_mkVBalBranch x1 x2 x3 z x5
    s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_mkVBalBranch x1 x2 x3 e x5 s
    cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.mkVBalBranch" [show x1
    , show x2, show x3, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.Map.mkVBalBranch" (showCons x4))

d_C_glueBal :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_glueBal x1 x2 cd cs = d_C__case_14 x1 x2 (d_C_null x1 cd cs) cd cs

d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore -> t1
d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 l cd cs)
    (d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.glueBal._#selFP15#mid_key1" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueBal._#selFP15#mid_key1" (showCons
    x1))

d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore -> t0
d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 l cd cs)
    (d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.glueBal._#selFP16#mid_elt1" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueBal._#selFP16#mid_elt1" (showCons
    x1))

d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore -> t1
d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x2
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 l cd cs)
    (d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.glueBal._#selFP13#mid_key2" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueBal._#selFP13#mid_key2" (showCons
    x1))

d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_Tuple2 t1 t0 -> Cover -> ConstStore -> t0
d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 x1 cd cs = case x1 of
  Curry_Prelude.OP_Tuple2 x2 x3 -> x3
  Curry_Prelude.Choice_OP_Tuple2 d i l r -> narrow d i
    (d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 l cd cs)
    (d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 r cd cs)
  Curry_Prelude.Choices_OP_Tuple2 d i xs -> narrows cs d i (\z ->
    d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 z cd cs) xs
  Curry_Prelude.Guard_OP_Tuple2 d c e -> guardCons d c ((\x ->
    d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2 e cd x) $! addCs c
    cs)
  Curry_Prelude.Fail_OP_Tuple2 d info -> failCons d (traceFail
    "Data.Map.glueBal._#selFP14#mid_elt2" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueBal._#selFP14#mid_elt2" (showCons
    x1))

d_C_glueVBal :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_glueVBal x1 x2 cd cs = d_C__case_11 x1 x2 (d_C_null x1 cd cs) cd cs

d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> t1
d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x2
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP23#key_l"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP23#key_l" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> t0
d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x3
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP24#elt_l"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP24#elt_l" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x5
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP25#fm_ll"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP25#fm_ll" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x6
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP26#fm_lr"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP26#fm_lr" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> t1
d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x2
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP19#key_r"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP19#key_r" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> t0
d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x3
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP20#elt_r"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP20#elt_r" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x5
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP21#fm_rl"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP21#fm_rl" (showCons x1))

d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr :: forall t0
  t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry t0) => C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr x1 cd cs = case x1 of
  C_Bin x2 x3 x4 x5 x6 -> x6
  Choice_C_Map d i l r -> narrow d i
    (d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr l cd cs)
    (d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z ->
    d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x ->
    d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.glueVBal._#selFP22#fm_rr"
    [show x1] info)
  _ -> failCons cd (consFail "Data.Map.glueVBal._#selFP22#fm_rr" (showCons x1))

d_C_splitLT :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t1 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_splitLT x1 x2 x3 cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_7 x4 x3 x1 x8 x7 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1 cd cs) x3 cd cs) x4 cd
    cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_splitLT x1 l x3 cd cs) (d_C_splitLT x1
    r x3 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_splitLT x1 z x3 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_splitLT x1 e x3 cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitLT" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitLT" (showCons x2))

nd_C_splitLT :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> t1 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C_splitLT x1 x2 x3 s cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_7 x4 x3 x1 x8 x7 x5 (let s3 = leftSupply s4
                                                              s2 = rightSupply
                                                                s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x3 s1 cd cs)) x4 s3 cd cs)) s5 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_splitLT x1 l x3 s cd cs)
    (nd_C_splitLT x1 r x3 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_splitLT x1 z x3 s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_splitLT x1 e x3 s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitLT" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitLT" (showCons x2))

d_C_splitGT :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t1 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C_splitGT x1 x2 x3 cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> d_C__case_5 x4 x3 x1 x8 x7 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1 cd cs) x3 cd cs) x4 cd
    cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_splitGT x1 l x3 cd cs) (d_C_splitGT x1
    r x3 cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_splitGT x1 z x3 cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_splitGT x1 e x3 cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitGT" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitGT" (showCons x2))

nd_C_splitGT :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> t1 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C_splitGT x1 x2 x3 s cd cs = case x2 of
  C_Tip -> C_Tip
  C_Bin x4 x5 x6 x7 x8 -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_5 x4 x3 x1 x8 x7 x5 (let s3 = leftSupply s4
                                                              s2 = rightSupply
                                                                s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x3 s1 cd cs)) x4 s3 cd cs)) s5 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C_splitGT x1 l x3 s cd cs)
    (nd_C_splitGT x1 r x3 s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C_splitGT x1 z x3 s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C_splitGT x1 e x3 s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.splitGT" [show x1, show
    x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map.splitGT" (showCons x2))

d_C_findMin :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
d_C_findMin x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.findMin: empty map") cd cs
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_3 x3 x2 x5 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_findMin l cd cs) (d_C_findMin r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_findMin z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_findMin e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.findMin" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.findMin" (showCons x1))

d_C_deleteMin :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_deleteMin x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.deleteMin: empty map") cd cs
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_2 x6 x3 x2 x5 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_deleteMin l cd cs) (d_C_deleteMin r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_deleteMin z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_deleteMin e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.deleteMin" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Map.deleteMin" (showCons x1))

d_C_findMax :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple2 t1 t0
d_C_findMax x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.findMax: empty map") cd cs
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_1 x3 x2 x6 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_findMax l cd cs) (d_C_findMax r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_findMax z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_findMax e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.findMax" [show x1] info)
  _ -> failCons cd (consFail "Data.Map.findMax" (showCons x1))

d_C_deleteMax :: forall t0 t1 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C_deleteMax x1 cd cs = case x1 of
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "FiniteMap.deleteMax: empty map") cd cs
  C_Bin x2 x3 x4 x5 x6 -> d_C__case_0 x5 x3 x2 x6 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C_deleteMax l cd cs) (d_C_deleteMax r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C_deleteMax z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C_deleteMax e cd x) $! addCs c
    cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map.deleteMax" [show x1]
    info)
  _ -> failCons cd (consFail "Data.Map.deleteMax" (showCons x1))

d_C__case_57 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> C_Map
  t1 t0 -> Curry_Prelude.C_Int -> t0 -> t1 -> C_Map t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool
d_C__case_57 x14 x2 x1 x13 x12 x11 x10 x4 cd cs = case x4 of
  C_Tip -> Curry_Prelude.C_False
  C_Bin x15 x16 x17 x18 x19 -> Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_OP_amp_amp
    (Curry_Prelude.d_OP_amp_amp (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq_eq x1 cd cs) x10 cd cs)
    x15 cd cs) (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_eq_eq_eq x2 cd cs) x11 cd cs) x16 cd cs) cd cs)
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int
    cd cs) x12 cd cs) x17 cd cs) cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 x13 x18 cd cs) cd cs)
    (d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 x14 x19 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_57 x14 x2 x1 x13 x12 x11 x10 l
    cd cs) (d_C__case_57 x14 x2 x1 x13 x12 x11 x10 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_57 x14 x2 x1 x13 x12
    x11 x10 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_57 x14 x2 x1 x13 x12 x11
    x10 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_57" [show x14, show
    x2, show x1, show x13, show x12, show x11, show x10, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_57" (showCons x4))

nd_C__case_57 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t0) -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Data t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Int -> t0 -> t1 -> C_Map t1 t0 -> IDSupply -> Cover
  -> ConstStore -> Curry_Prelude.C_Bool
nd_C__case_57 x14 x2 x1 x13 x12 x11 x10 x4 s cd cs = case x4 of
  C_Tip -> Curry_Prelude.C_False
  C_Bin x15 x16 x17 x18 x19 -> let s18 = s
    in s18 `seq` (let s16 = leftSupply s18
                      s17 = rightSupply s18
    in s16 `seq` (s17 `seq` Curry_Prelude.d_OP_amp_amp (let s14 = leftSupply s16
                                                            s15 = rightSupply
                                                              s16
    in s14 `seq` (s15 `seq` Curry_Prelude.d_OP_amp_amp (let s10 = leftSupply s14
                                                            s13 = rightSupply
                                                              s14
    in s10 `seq` (s13 `seq` Curry_Prelude.d_OP_amp_amp (let s4 = leftSupply s10
                                                            s9 = rightSupply s10
    in s4 `seq` (s9 `seq` Curry_Prelude.d_OP_amp_amp (let s3 = leftSupply s4
                                                          s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x1 s0 cd cs) x10 s1 cd cs)) x15 s3 cd cs)) (let s8 = leftSupply s9
                                                    s7 = rightSupply s9
    in s8 `seq` (s7 `seq` Curry_Prelude.nd_C_apply (let s6 = leftSupply s7
                                                        s5 = rightSupply s7
    in s6 `seq` (s5 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_eq_eq_eq
    x2 s5 cd cs) x11 s6 cd cs)) x16 s8 cd cs)) cd cs)) (let s12 = leftSupply s13
                                                            s11 = rightSupply
                                                              s13
    in s12 `seq` (s11 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Prelude_dot_Int
    cd cs)) x12 s11 cd cs) x17 s12 cd cs)) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 x13 x18 s15 cd cs) cd cs))
    (nd_OP_uscore_impl_hash_eq_eq_eq_hash_Prelude_dot_Data_hash_Data_dot_Map_dot_Map
    x1 x2 x14 x19 s17 cd cs) cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_57 x14 x2 x1 x13 x12 x11 x10 l
    s cd cs) (nd_C__case_57 x14 x2 x1 x13 x12 x11 x10 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_57 x14 x2 x1 x13 x12
    x11 x10 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_57 x14 x2 x1 x13 x12 x11
    x10 e s cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_57" [show x14, show
    x2, show x1, show x13, show x12, show x11, show x10, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_57" (showCons x4))

d_C__case_58 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Cover -> ConstStore -> Curry_Prelude.C_Bool
d_C__case_58 x4 cd cs = case x4 of
  C_Tip -> Curry_Prelude.C_True
  C_Bin x5 x6 x7 x8 x9 -> Curry_Prelude.C_False
  Choice_C_Map d i l r -> narrow d i (d_C__case_58 l cd cs) (d_C__case_58 r cd
    cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_58 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_58 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_58" [show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_58" (showCons x4))

d_C__case_56 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_56 x3 x2 x4 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Cons (Curry_Prelude.OP_Tuple2 C_Tip
    x4) x2
  Curry_Prelude.C_False -> x2
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_56 x3 x2 x4 l cd
    cs) (d_C__case_56 x3 x2 x4 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_56 x3
    x2 x4 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_56 x3 x2
    x4 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_56"
    [show x3, show x2, show x4, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_56" (showCons x5))

d_C__case_55 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char))
d_C__case_55 x5 x4 x6 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> Curry_Prelude.d_OP_plus_plus (Curry_Prelude.d_C_foldr
    (acceptCs id
    (d_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2)) Curry_Prelude.OP_List (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_readsPrec x2 cd cs)
    (Curry_Prelude.C_Int (11)) cd cs) x6 cd cs) cd cs) x4 cd cs
  Curry_Prelude.C_False -> x4
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_55 x5 x4 x6 x2 x1
    l cd cs) (d_C__case_55 x5 x4 x6 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_55 x5
    x4 x6 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_55 x5 x4
    x6 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_55"
    [show x5, show x4, show x6, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_55" (showCons x7))

nd_C__case_55 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.OP_List Curry_Prelude.C_Char -> Curry_Prelude.OP_List
  (Curry_Prelude.OP_Tuple2 (C_Map t1 t0) (Curry_Prelude.OP_List
  Curry_Prelude.C_Char)) -> Curry_Prelude.OP_List Curry_Prelude.C_Char -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t1) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Read t0)
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_List (Curry_Prelude.OP_Tuple2 (C_Map t1 t0)
  (Curry_Prelude.OP_List Curry_Prelude.C_Char))
nd_C__case_55 x5 x4 x6 x2 x1 x7 s cd cs = case x7 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` Curry_Prelude.d_OP_plus_plus (let s5 = leftSupply s6
                                                  s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_foldr (wrapDX (wrapNX id) (acceptCs
    id
    (nd_OP_uscore_impl_hash_readsPrec_hash_Prelude_dot_Read_hash_Data_dot_Map_dot_Map_dot_uscore_hash_lambda6_dot_uscore_hash_lambda9_dot_uscore_hash_lambda13
    x1 x2))) Curry_Prelude.OP_List (let s3 = leftSupply s4
                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_readsPrec
    x2 s0 cd cs) (Curry_Prelude.C_Int (11)) s1 cd cs)) x6 s3 cd cs)) s5 cd cs))
    x4 cd cs
  Curry_Prelude.C_False -> x4
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_55 x5 x4 x6 x2
    x1 l s cd cs) (nd_C__case_55 x5 x4 x6 x2 x1 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_55 x5
    x4 x6 x2 x1 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_55 x5 x4
    x6 x2 x1 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_55"
    [show x5, show x4, show x6, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_55" (showCons x7))

d_C__case_54 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Map t1 t0
d_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x6 x7 (d_C_insertWith x1 x2 x3 x4 x9
    cd cs) x10 cd cs
  Curry_Prelude.C_False -> d_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x3 cd cs) x6 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_54 x6 x3 x1 x10
    x4 x2 x9 x7 x8 l cd cs) (d_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_54 x6
    x3 x1 x10 x4 x2 x9 x7 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_54 x6 x3
    x1 x10 x4 x2 x9 x7 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_54"
    [show x6, show x3, show x1, show x10, show x4, show x2, show x9, show x7
    , show x8, show x11] info)
  _ -> failCons cd (consFail "Data.Map._case_54" (showCons x11))

nd_C__case_54 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> Func t0
  (Func t0 t0) -> C_Map t1 t0 -> t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x6 x7 (nd_C_insertWith x1 x2 x3 x4 x9 s0 cd cs)
    x10 cd cs
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8
    (let s5 = leftSupply s6
         s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x3 s3 cd cs)) x6 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_54 x6 x3 x1 x10
    x4 x2 x9 x7 x8 l s cd cs) (nd_C__case_54 x6 x3 x1 x10 x4 x2 x9 x7 x8 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_54 x6
    x3 x1 x10 x4 x2 x9 x7 x8 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_54 x6 x3
    x1 x10 x4 x2 x9 x7 x8 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_54"
    [show x6, show x3, show x1, show x10, show x4, show x2, show x9, show x7
    , show x8, show x11] info)
  _ -> failCons cd (consFail "Data.Map._case_54" (showCons x11))

d_C__case_53 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> (t0
  -> Cover -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Int -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> C_Map t1 t0
d_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8 x11 cd cs = case x11 of
  Curry_Prelude.C_True -> C_Bin x3 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x7 cd cs) x4 cd cs) x8 x9 x10
  Curry_Prelude.C_False -> d_C_mkBalBranch x6 x7 x9 (d_C_insertWith x1 x2 x3 x4
    x10 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_53 x6 x3 x1 x10
    x4 x2 x9 x7 x8 l cd cs) (d_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_53 x6
    x3 x1 x10 x4 x2 x9 x7 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_53 x6 x3
    x1 x10 x4 x2 x9 x7 x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_53"
    [show x6, show x3, show x1, show x10, show x4, show x2, show x9, show x7
    , show x8, show x11] info)
  _ -> failCons cd (consFail "Data.Map._case_53" (showCons x11))

nd_C__case_53 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> Func t0
  (Func t0 t0) -> C_Map t1 t0 -> t0 -> Curry_Prelude.C_Int
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8 x11 s cd cs = case x11 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` C_Bin x3 (let s1 = leftSupply s2
                              s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x7 s0 cd cs) x4 s1 cd cs)) x8 x9 x10
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x6 x7 x9 (nd_C_insertWith x1 x2 x3 x4 x10 s0 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_53 x6 x3 x1 x10
    x4 x2 x9 x7 x8 l s cd cs) (nd_C__case_53 x6 x3 x1 x10 x4 x2 x9 x7 x8 r s cd
    cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_53 x6
    x3 x1 x10 x4 x2 x9 x7 x8 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_53 x6 x3
    x1 x10 x4 x2 x9 x7 x8 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_53"
    [show x6, show x3, show x1, show x10, show x4, show x2, show x9, show x7
    , show x8, show x11] info)
  _ -> failCons cd (consFail "Data.Map._case_53" (showCons x11))

d_C__case_52 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_52 x4 x2 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x4 x5 (d_C_delete x1 x2 x7 cd cs) x8
    cd cs
  Curry_Prelude.C_False -> d_C__case_51 x4 x2 x1 x8 x7 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x2 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_52 x4 x2 x1 x8 x7
    x5 l cd cs) (d_C__case_52 x4 x2 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_52 x4
    x2 x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_52 x4 x2
    x1 x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_52"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_52" (showCons x9))

nd_C__case_52 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_52 x4 x2 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x4 x5 (nd_C_delete x1 x2 x7 s0 cd cs) x8 cd cs
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_51 x4 x2 x1 x8 x7 x5 (let s5 = leftSupply
                                                                 s6
                                                               s4 = rightSupply
                                                                 s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x2 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_52 x4 x2 x1 x8
    x7 x5 l s cd cs) (nd_C__case_52 x4 x2 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_52 x4
    x2 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_52 x4 x2
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_52"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_52" (showCons x9))

d_C__case_51 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_51 x4 x2 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_glueBal x7 x8 cd cs
  Curry_Prelude.C_False -> d_C_mkBalBranch x4 x5 x7 (d_C_delete x1 x2 x8 cd cs)
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_51 x4 x2 x1 x8 x7
    x5 l cd cs) (d_C__case_51 x4 x2 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_51 x4
    x2 x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_51 x4 x2
    x1 x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_51"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_51" (showCons x9))

nd_C__case_51 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_51 x4 x2 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_glueBal x7 x8 cd cs
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x4 x5 x7 (nd_C_delete x1 x2 x8 s0 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_51 x4 x2 x1 x8
    x7 x5 l s cd cs) (nd_C__case_51 x4 x2 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_51 x4
    x2 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_51 x4 x2
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_51"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_51" (showCons x9))

d_C__case_50 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> (t0 -> Cover
  -> ConstStore -> t0) -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> C_Bin x5 (Curry_Prelude.d_C_apply x2 x6 cd cs) x7 x8
    x9
  Curry_Prelude.C_False -> d_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1
    cd cs) x3 cd cs) x5 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_50 x5 x3 x1 x9 x2
    x8 x7 x6 l cd cs) (d_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_50 x5
    x3 x1 x9 x2 x8 x7 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_50 x5 x3
    x1 x9 x2 x8 x7 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_50"
    [show x5, show x3, show x1, show x9, show x2, show x8, show x7, show x6
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_50" (showCons x10))

nd_C__case_50 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> Func t0 t0
  -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` C_Bin x5 (Curry_Prelude.nd_C_apply x2 x6 s0 cd cs) x7 x8 x9
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6
    (let s3 = leftSupply s4
         s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x3 s1 cd cs)) x5 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_50 x5 x3 x1 x9
    x2 x8 x7 x6 l s cd cs) (nd_C__case_50 x5 x3 x1 x9 x2 x8 x7 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_50 x5
    x3 x1 x9 x2 x8 x7 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_50 x5 x3
    x1 x9 x2 x8 x7 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_50"
    [show x5, show x3, show x1, show x9, show x2, show x8, show x7, show x6
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_50" (showCons x10))

d_C__case_49 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> (t0 -> Cover
  -> ConstStore -> t0) -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> C_Bin x5 x6 x7 (d_C_adjust x1 x2 x3 x8 cd cs) x9
  Curry_Prelude.C_False -> d_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_49 x5 x3 x1 x9 x2
    x8 x7 x6 l cd cs) (d_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_49 x5
    x3 x1 x9 x2 x8 x7 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_49 x5 x3
    x1 x9 x2 x8 x7 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_49"
    [show x5, show x3, show x1, show x9, show x2, show x8, show x7, show x6
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_49" (showCons x10))

nd_C__case_49 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> Func t0 t0
  -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` C_Bin x5 x6 x7 (nd_C_adjust x1 x2 x3 x8 s0 cd cs) x9
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5
    (Curry_Prelude.d_C_otherwise cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_49 x5 x3 x1 x9
    x2 x8 x7 x6 l s cd cs) (nd_C__case_49 x5 x3 x1 x9 x2 x8 x7 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_49 x5
    x3 x1 x9 x2 x8 x7 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_49 x5 x3
    x1 x9 x2 x8 x7 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_49"
    [show x5, show x3, show x1, show x9, show x2, show x8, show x7, show x6
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_49" (showCons x10))

d_C__case_48 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> (t0 -> Cover -> ConstStore -> t0)
  -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Int -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5 x10 cd cs = case x10 of
  Curry_Prelude.C_True -> C_Bin x5 x6 x7 x8 (d_C_adjust x1 x2 x3 x9 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_48 x9 x3 x2 x1 x8
    x7 x6 x5 l cd cs) (d_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_48 x9
    x3 x2 x1 x8 x7 x6 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_48 x9 x3
    x2 x1 x8 x7 x6 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_48"
    [show x9, show x3, show x2, show x1, show x8, show x7, show x6, show x5
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_48" (showCons x10))

nd_C__case_48 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> Func t0 t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Int -> t0 -> t1 -> Curry_Prelude.C_Bool -> IDSupply
  -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5 x10 s cd cs = case x10 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` C_Bin x5 x6 x7 x8 (nd_C_adjust x1 x2 x3 x9 s0 cd cs)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_48 x9 x3 x2 x1
    x8 x7 x6 x5 l s cd cs) (nd_C__case_48 x9 x3 x2 x1 x8 x7 x6 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_48 x9
    x3 x2 x1 x8 x7 x6 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_48 x9 x3
    x2 x1 x8 x7 x6 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_48"
    [show x9, show x3, show x2, show x1, show x8, show x7, show x6, show x5
    , show x10] info)
  _ -> failCons cd (consFail "Data.Map._case_48" (showCons x10))

d_C__case_47 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1
  t0)
d_C__case_47 x4 x2 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x7 (Curry_Prelude.C_Just x5)
    x8
  Curry_Prelude.C_False -> d_C__case_46 x4 x2 x1 x8 x7 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_lt x1 cd cs) x2 cd cs) x4 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_47 x4 x2 x1 x8 x7
    x5 l cd cs) (d_C__case_47 x4 x2 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_47 x4
    x2 x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_47 x4 x2
    x1 x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_47"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_47" (showCons x9))

nd_C__case_47 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1
  t0)
nd_C__case_47 x4 x2 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.OP_Tuple3 x7 (Curry_Prelude.C_Just x5)
    x8
  Curry_Prelude.C_False -> let s6 = s
    in s6 `seq` (let s5 = leftSupply s6
                     s4 = rightSupply s6
    in s5 `seq` (s4 `seq` nd_C__case_46 x4 x2 x1 x8 x7 (let s3 = leftSupply s4
                                                            s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_OP_lt x1 s0
    cd cs) x2 s1 cd cs)) x4 s3 cd cs)) s5 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_47 x4 x2 x1 x8
    x7 x5 l s cd cs) (nd_C__case_47 x4 x2 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_47 x4
    x2 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_47 x4 x2
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_47"
    [show x4, show x2, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_47" (showCons x9))

d_C__case_46 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1 t0)
d_C__case_46 x4 x2 x1 x8 x7 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> let x9 = d_C_splitLookup x1 x2 x7 cd cs
                              x10 = d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick
                                x9 cd cs
                              x11 = d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v
                                x9 cd cs
                              x12 = d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick
                                x9 cd cs
    in Curry_Prelude.OP_Tuple3 x10 x11 (d_C_glueBal x12 x8 cd cs)
  Curry_Prelude.C_False -> d_C__case_45 x8 x2 x1 x7 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_46 x4 x2 x1 x8 x7
    l cd cs) (d_C__case_46 x4 x2 x1 x8 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_46 x4
    x2 x1 x8 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_46 x4 x2
    x1 x8 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_46"
    [show x4, show x2, show x1, show x8, show x7, show x13] info)
  _ -> failCons cd (consFail "Data.Map._case_46" (showCons x13))

nd_C__case_46 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1
  t0)
nd_C__case_46 x4 x2 x1 x8 x7 x13 s cd cs = case x13 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x9 = nd_C_splitLookup x1 x2 x7 s0 cd cs
                     x10 = d_OP_splitLookup_dot_uscore_hash_selFP2_hash_m_uscore_l_tick
                       x9 cd cs
                     x11 = d_OP_splitLookup_dot_uscore_hash_selFP3_hash_v x9 cd
                       cs
                     x12 = d_OP_splitLookup_dot_uscore_hash_selFP4_hash_m_uscore_r_tick
                       x9 cd cs
    in Curry_Prelude.OP_Tuple3 x10 x11 (d_C_glueBal x12 x8 cd cs))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_45 x8 x2 x1 x7 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_46 x4 x2 x1 x8
    x7 l s cd cs) (nd_C__case_46 x4 x2 x1 x8 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_46 x4
    x2 x1 x8 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_46 x4 x2
    x1 x8 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_46"
    [show x4, show x2, show x1, show x8, show x7, show x13] info)
  _ -> failCons cd (consFail "Data.Map._case_46" (showCons x13))

d_C__case_45 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.OP_Tuple3
  (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1 t0)
d_C__case_45 x8 x2 x1 x7 x17 cd cs = case x17 of
  Curry_Prelude.C_True -> let x13 = d_C_splitLookup x1 x2 x8 cd cs
                              x14 = d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick
                                x13 cd cs
                              x15 = d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v
                                x13 cd cs
                              x16 = d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick
                                x13 cd cs
    in Curry_Prelude.OP_Tuple3 (d_C_glueBal x7 x14 cd cs) x15 x16
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_45 x8 x2 x1 x7 l
    cd cs) (d_C__case_45 x8 x2 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_45 x8
    x2 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_45 x8 x2
    x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_45"
    [show x8, show x2, show x1, show x7, show x17] info)
  _ -> failCons cd (consFail "Data.Map._case_45" (showCons x17))

nd_C__case_45 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple3 (C_Map t1 t0) (Curry_Prelude.C_Maybe t0) (C_Map t1
  t0)
nd_C__case_45 x8 x2 x1 x7 x17 s cd cs = case x17 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` (let x13 = nd_C_splitLookup x1 x2 x8 s0 cd cs
                     x14 = d_OP_splitLookup_dot_uscore_hash_selFP6_hash_m_uscore_l_tick
                       x13 cd cs
                     x15 = d_OP_splitLookup_dot_uscore_hash_selFP7_hash_v x13 cd
                       cs
                     x16 = d_OP_splitLookup_dot_uscore_hash_selFP8_hash_m_uscore_r_tick
                       x13 cd cs
    in Curry_Prelude.OP_Tuple3 (d_C_glueBal x7 x14 cd cs) x15 x16)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_45 x8 x2 x1 x7 l
    s cd cs) (nd_C__case_45 x8 x2 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_45 x8
    x2 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_45 x8 x2
    x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_45"
    [show x8, show x2, show x1, show x7, show x17] info)
  _ -> failCons cd (consFail "Data.Map._case_45" (showCons x17))

d_C__case_44 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> C_Map t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_44 x4 x1 x8 x7 x5 x2 x3 cd cs = case x3 of
  C_Tip -> x2
  C_Bin x9 x10 x11 x12 x13 -> let x14 = d_C_splitLT x1 x3 x4 cd cs
                                  x15 = d_C_splitGT x1 x3 x4 cd cs
    in d_C_mkVBalBranch x1 x4 x5 (d_C_union x1 x7 x14 cd cs) (d_C_union x1 x8
    x15 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_44 x4 x1 x8 x7 x5 x2 l cd cs)
    (d_C__case_44 x4 x1 x8 x7 x5 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_44 x4 x1 x8 x7 x5 x2 z
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_44 x4 x1 x8 x7 x5 x2 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_44" [show x4, show
    x1, show x8, show x7, show x5, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_44" (showCons x3))

nd_C__case_44 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0 -> C_Map t1 t0 -> C_Map t1 t0
  -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_44 x4 x1 x8 x7 x5 x2 x3 s cd cs = case x3 of
  C_Tip -> x2
  C_Bin x9 x10 x11 x12 x13 -> let s7 = s
    in s7 `seq` (let s0 = leftSupply s7
                     s8 = rightSupply s7
                     s1 = leftSupply s8
                     s5 = rightSupply s8
    in s0 `seq` (s8 `seq` (s1 `seq` (s5 `seq` (let x14 = nd_C_splitLT x1 x3 x4
                                                     s0 cd cs
                                                   x15 = nd_C_splitGT x1 x3 x4
                                                     s1 cd cs
    in let s4 = leftSupply s5
           s6 = rightSupply s5
           s2 = leftSupply s6
           s3 = rightSupply s6
    in s4 `seq` (s6 `seq` (s2 `seq` (s3 `seq` nd_C_mkVBalBranch x1 x4 x5
    (nd_C_union x1 x7 x14 s2 cd cs) (nd_C_union x1 x8 x15 s3 cd cs) s4 cd
    cs))))))))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_44 x4 x1 x8 x7 x5 x2 l s cd cs)
    (nd_C__case_44 x4 x1 x8 x7 x5 x2 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_44 x4 x1 x8 x7 x5 x2
    z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_44 x4 x1 x8 x7 x5 x2 e s
    cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_44" [show x4, show
    x1, show x8, show x7, show x5, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_44" (showCons x3))

d_C__case_43 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> C_Map t1 t0 -> C_Map t1
  t0 -> C_Map t1 t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_43 x5 x1 x6 x2 x9 x8 x3 x4 cd cs = case x4 of
  C_Tip -> x3
  C_Bin x10 x11 x12 x13 x14 -> let x15 = d_C_splitLT x1 x4 x5 cd cs
                                   x16 = d_C_splitGT x1 x4 x5 cd cs
                                   x17 = d_C__case_42 x4 x5 x1 x6 x2 (d_C_lookup
                                     x1 x5 x4 cd cs) cd cs
    in d_C_mkVBalBranch x1 x5 x17 (d_C_unionWith x1 x2 x8 x15 cd cs)
    (d_C_unionWith x1 x2 x9 x16 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_43 x5 x1 x6 x2 x9 x8 x3 l cd cs)
    (d_C__case_43 x5 x1 x6 x2 x9 x8 x3 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_43 x5 x1 x6 x2 x9 x8
    x3 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_43 x5 x1 x6 x2 x9 x8 x3 e
    cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_43" [show x5, show
    x1, show x6, show x2, show x9, show x8, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_43" (showCons x4))

nd_C__case_43 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t1) -> t0 -> Func t0 (Func t0 t0) -> C_Map t1 t0 -> C_Map t1 t0 -> C_Map t1 t0
  -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_43 x5 x1 x6 x2 x9 x8 x3 x4 s cd cs = case x4 of
  C_Tip -> x3
  C_Bin x10 x11 x12 x13 x14 -> let s10 = s
    in s10 `seq` (let s11 = leftSupply s10
                      s12 = rightSupply s10
                      s0 = leftSupply s11
                      s1 = rightSupply s11
                      s4 = leftSupply s12
                      s8 = rightSupply s12
    in s11 `seq` (s12 `seq` (s0 `seq` (s1 `seq` (s4 `seq` (s8 `seq`
    (let x15 = nd_C_splitLT x1 x4 x5 s0 cd cs
         x16 = nd_C_splitGT x1 x4 x5 s1 cd cs
         x17 = let s3 = leftSupply s4
                   s2 = rightSupply s4
           in s3 `seq` (s2 `seq` nd_C__case_42 x4 x5 x1 x6 x2 (nd_C_lookup x1 x5
           x4 s2 cd cs) s3 cd cs)
    in let s7 = leftSupply s8
           s9 = rightSupply s8
           s5 = leftSupply s9
           s6 = rightSupply s9
    in s7 `seq` (s9 `seq` (s5 `seq` (s6 `seq` nd_C_mkVBalBranch x1 x5 x17
    (nd_C_unionWith x1 x2 x8 x15 s5 cd cs) (nd_C_unionWith x1 x2 x9 x16 s6 cd
    cs) s7 cd cs))))))))))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_43 x5 x1 x6 x2 x9 x8 x3 l s cd
    cs) (nd_C__case_43 x5 x1 x6 x2 x9 x8 x3 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_43 x5 x1 x6 x2 x9 x8
    x3 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_43 x5 x1 x6 x2 x9 x8 x3
    e s cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_43" [show x5, show
    x1, show x6, show x2, show x9, show x8, show x3, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_43" (showCons x4))

d_C__case_42 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> (t0 -> Cover
  -> ConstStore -> t0 -> Cover -> ConstStore -> t0) -> Curry_Prelude.C_Maybe t0
  -> Cover -> ConstStore -> t0
d_C__case_42 x4 x5 x1 x6 x2 x19 cd cs = case x19 of
  Curry_Prelude.C_Nothing -> x6
  Curry_Prelude.C_Just x18 -> Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    x2 x18 cd cs) x6 cd cs
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_42 x4 x5 x1 x6
    x2 l cd cs) (d_C__case_42 x4 x5 x1 x6 x2 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_42 x4
    x5 x1 x6 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_42 x4 x5
    x1 x6 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "Data.Map._case_42"
    [show x4, show x5, show x1, show x6, show x2, show x19] info)
  _ -> failCons cd (consFail "Data.Map._case_42" (showCons x19))

nd_C__case_42 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> Func t0 (Func t0 t0)
  -> Curry_Prelude.C_Maybe t0 -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_42 x4 x5 x1 x6 x2 x19 s cd cs = case x19 of
  Curry_Prelude.C_Nothing -> x6
  Curry_Prelude.C_Just x18 -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x18 s0 cd cs) x6 s1 cd cs))
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_42 x4 x5 x1 x6
    x2 l s cd cs) (nd_C__case_42 x4 x5 x1 x6 x2 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_42 x4
    x5 x1 x6 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> nd_C__case_42 x4 x5
    x1 x6 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "Data.Map._case_42"
    [show x4, show x5, show x1, show x6, show x2, show x19] info)
  _ -> failCons cd (consFail "Data.Map._case_42" (showCons x19))

d_C__case_41 :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => C_Map t1 t2 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t2
d_C__case_41 x2 x1 x3 cd cs = case x3 of
  C_Tip -> x2
  C_Bin x9 x10 x11 x12 x13 -> let x14 = d_C_splitLT x1 x2 x9 cd cs
                                  x15 = d_C_splitGT x1 x2 x9 cd cs
    in d_C_glueVBal (d_C_difference x1 x14 x12 cd cs) (d_C_difference x1 x15 x13
    cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_41 x2 x1 l cd cs) (d_C__case_41
    x2 x1 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_41 x2 x1 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_41 x2 x1 e cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_41" [show x2, show
    x1, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_41" (showCons x3))

nd_C__case_41 :: forall t1 t2 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t2, Curry_Prelude.Curry t0) => C_Map t1 t2 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> IDSupply -> Cover
  -> ConstStore -> C_Map t1 t2
nd_C__case_41 x2 x1 x3 s cd cs = case x3 of
  C_Tip -> x2
  C_Bin x9 x10 x11 x12 x13 -> let s5 = s
    in s5 `seq` (let s0 = leftSupply s5
                     s6 = rightSupply s5
                     s1 = leftSupply s6
                     s4 = rightSupply s6
    in s0 `seq` (s6 `seq` (s1 `seq` (s4 `seq` (let x14 = nd_C_splitLT x1 x2 x9
                                                     s0 cd cs
                                                   x15 = nd_C_splitGT x1 x2 x9
                                                     s1 cd cs
    in let s2 = leftSupply s4
           s3 = rightSupply s4
    in s2 `seq` (s3 `seq` d_C_glueVBal (nd_C_difference x1 x14 x12 s2 cd cs)
    (nd_C_difference x1 x15 x13 s3 cd cs) cd cs))))))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_41 x2 x1 l s cd cs)
    (nd_C__case_41 x2 x1 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_41 x2 x1 z s cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_41 x2 x1 e s cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_41" [show x2, show
    x1, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_41" (showCons x3))

d_C__case_40 :: forall t2 t1 t3 t0 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => t2 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> C_Map t2 t1 -> (t3 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> C_Map t2 t1 -> t1
  -> C_Map t2 t3 -> Cover -> ConstStore -> C_Map t2 t0
d_C__case_40 x5 x1 x9 x2 x8 x6 x3 cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x10 x11 x12 x13 x14 -> let x15 = d_C_splitLT x1 x3 x5 cd cs
                                   x16 = d_C_splitGT x1 x3 x5 cd cs
                                   x17 = d_C_lookup x1 x5 x3 cd cs
                                   x18 = d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick
                                     x17 cd cs
    in d_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18 x5
    (Data.Curry_Maybe.d_C_isJust x17 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_40 x5 x1 x9 x2 x8 x6 l cd cs)
    (d_C__case_40 x5 x1 x9 x2 x8 x6 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_40 x5 x1 x9 x2 x8 x6 z
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_40 x5 x1 x9 x2 x8 x6 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_40" [show x5, show
    x1, show x9, show x2, show x8, show x6, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_40" (showCons x3))

nd_C__case_40 :: forall t2 t1 t3 t0 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => t2 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t2) -> C_Map t2 t1 -> Func t3 (Func t1 t0) -> C_Map t2 t1 -> t1 -> C_Map t2 t3
  -> IDSupply -> Cover -> ConstStore -> C_Map t2 t0
nd_C__case_40 x5 x1 x9 x2 x8 x6 x3 s cd cs = case x3 of
  C_Tip -> C_Tip
  C_Bin x10 x11 x12 x13 x14 -> let s4 = s
    in s4 `seq` (let s5 = leftSupply s4
                     s6 = rightSupply s4
                     s0 = leftSupply s5
                     s1 = rightSupply s5
                     s2 = leftSupply s6
                     s3 = rightSupply s6
    in s5 `seq` (s6 `seq` (s0 `seq` (s1 `seq` (s2 `seq` (s3 `seq`
    (let x15 = nd_C_splitLT x1 x3 x5 s0 cd cs
         x16 = nd_C_splitGT x1 x3 x5 s1 cd cs
         x17 = nd_C_lookup x1 x5 x3 s2 cd cs
         x18 = d_OP_intersectionWith_dot_uscore_hash_selFP10_hash_a1_tick x17 cd
           cs
    in nd_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18 x5
    (Data.Curry_Maybe.d_C_isJust x17 cd cs) s3 cd cs)))))))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_40 x5 x1 x9 x2 x8 x6 l s cd cs)
    (nd_C__case_40 x5 x1 x9 x2 x8 x6 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_40 x5 x1 x9 x2 x8 x6
    z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_40 x5 x1 x9 x2 x8 x6 e s
    cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_40" [show x5, show
    x1, show x9, show x2, show x8, show x6, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_40" (showCons x3))

d_C__case_39 :: forall t3 t2 t1 t0 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Maybe t3 -> C_Map t2 t1 -> C_Map t2 t3 -> (t3 -> Cover
  -> ConstStore -> t1 -> Cover -> ConstStore -> t0) -> (Curry_Prelude.OP_Unit
  -> Cover -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> C_Map
  t2 t1 -> C_Map t2 t3 -> t1 -> t3 -> t2 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t2 t0
d_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18 x5 x19 cd cs = case x19 of
  Curry_Prelude.C_True -> d_C_mkVBalBranch x1 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply x2 x18 cd cs) x6 cd cs) (d_C_intersectionWith x1 x2
    x15 x8 cd cs) (d_C_intersectionWith x1 x2 x16 x9 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_38 x9 x16 x2 x1 x8 x15
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_39 x17 x9 x16 x2
    x1 x8 x15 x6 x18 x5 l cd cs) (d_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18 x5
    r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_39 x17
    x9 x16 x2 x1 x8 x15 x6 x18 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_39 x17 x9
    x16 x2 x1 x8 x15 x6 x18 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_39"
    [show x17, show x9, show x16, show x2, show x1, show x8, show x15, show x6
    , show x18, show x5, show x19] info)
  _ -> failCons cd (consFail "Data.Map._case_39" (showCons x19))

nd_C__case_39 :: forall t3 t2 t1 t0 . (Curry_Prelude.Curry t3
  , Curry_Prelude.Curry t2, Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Maybe t3 -> C_Map t2 t1 -> C_Map t2 t3 -> Func t3 (Func
  t1 t0) -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord
  t2) -> C_Map t2 t1 -> C_Map t2 t3 -> t1 -> t3 -> t2 -> Curry_Prelude.C_Bool
  -> IDSupply -> Cover -> ConstStore -> C_Map t2 t0
nd_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18 x5 x19 s cd cs = case x19 of
  Curry_Prelude.C_True -> let s6 = s
    in s6 `seq` (let s7 = leftSupply s6
                     s8 = rightSupply s6
                     s5 = leftSupply s7
                     s2 = rightSupply s7
                     s3 = leftSupply s8
                     s4 = rightSupply s8
    in s7 `seq` (s8 `seq` (s5 `seq` (s2 `seq` (s3 `seq` (s4 `seq`
    nd_C_mkVBalBranch x1 x5 (let s1 = leftSupply s2
                                 s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply x2
    x18 s0 cd cs) x6 s1 cd cs)) (nd_C_intersectionWith x1 x2 x15 x8 s3 cd cs)
    (nd_C_intersectionWith x1 x2 x16 x9 s4 cd cs) s5 cd cs))))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_38 x9 x16 x2 x1 x8 x15 (Curry_Prelude.d_C_otherwise
    cd cs) s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_39 x17 x9 x16 x2
    x1 x8 x15 x6 x18 x5 l s cd cs) (nd_C__case_39 x17 x9 x16 x2 x1 x8 x15 x6 x18
    x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_39 x17
    x9 x16 x2 x1 x8 x15 x6 x18 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_39 x17 x9
    x16 x2 x1 x8 x15 x6 x18 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_39"
    [show x17, show x9, show x16, show x2, show x1, show x8, show x15, show x6
    , show x18, show x5, show x19] info)
  _ -> failCons cd (consFail "Data.Map._case_39" (showCons x19))

d_C__case_38 :: forall t2 t1 t3 t0 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => C_Map t2 t1 -> C_Map t2 t3 -> (t3 -> Cover -> ConstStore -> t1 -> Cover
  -> ConstStore -> t0) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> C_Map t2 t1 -> C_Map t2 t3
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t2 t0
d_C__case_38 x9 x16 x2 x1 x8 x15 x17 cd cs = case x17 of
  Curry_Prelude.C_True -> d_C_glueVBal (d_C_intersectionWith x1 x2 x15 x8 cd cs)
    (d_C_intersectionWith x1 x2 x16 x9 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_38 x9 x16 x2 x1
    x8 x15 l cd cs) (d_C__case_38 x9 x16 x2 x1 x8 x15 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_38 x9
    x16 x2 x1 x8 x15 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_38 x9 x16
    x2 x1 x8 x15 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_38"
    [show x9, show x16, show x2, show x1, show x8, show x15, show x17] info)
  _ -> failCons cd (consFail "Data.Map._case_38" (showCons x17))

nd_C__case_38 :: forall t2 t1 t3 t0 . (Curry_Prelude.Curry t2
  , Curry_Prelude.Curry t1, Curry_Prelude.Curry t3, Curry_Prelude.Curry
  t0) => C_Map t2 t1 -> C_Map t2 t3 -> Func t3 (Func t1 t0) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t2) -> C_Map t2
  t1 -> C_Map t2 t3 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> C_Map t2 t0
nd_C__case_38 x9 x16 x2 x1 x8 x15 x17 s cd cs = case x17 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_glueVBal (nd_C_intersectionWith x1 x2 x15 x8 s0 cd
    cs) (nd_C_intersectionWith x1 x2 x16 x9 s1 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_38 x9 x16 x2 x1
    x8 x15 l s cd cs) (nd_C__case_38 x9 x16 x2 x1 x8 x15 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_38 x9
    x16 x2 x1 x8 x15 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_38 x9 x16
    x2 x1 x8 x15 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_38"
    [show x9, show x16, show x2, show x1, show x8, show x15, show x17] info)
  _ -> failCons cd (consFail "Data.Map._case_38" (showCons x17))

d_C__case_37 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> (t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> C_Map t1 t0 -> (Curry_Prelude.OP_Unit -> Cover
  -> ConstStore -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_37 x5 x4 x2 x8 x1 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_mkVBalBranch x1 x4 x5 (d_C_filterWithKey x1 x2 x7
    cd cs) (d_C_filterWithKey x1 x2 x8 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_36 x8 x2 x1 x7 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_37 x5 x4 x2 x8 x1
    x7 l cd cs) (d_C__case_37 x5 x4 x2 x8 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_37 x5
    x4 x2 x8 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_37 x5 x4
    x2 x8 x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_37"
    [show x5, show x4, show x2, show x8, show x1, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_37" (showCons x9))

nd_C__case_37 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> Func t1 (Func t0 Curry_Prelude.C_Bool) -> C_Map t1 t0
  -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> C_Map t1 t0
nd_C__case_37 x5 x4 x2 x8 x1 x7 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s3 = s
    in s3 `seq` (let s2 = leftSupply s3
                     s4 = rightSupply s3
                     s0 = leftSupply s4
                     s1 = rightSupply s4
    in s2 `seq` (s4 `seq` (s0 `seq` (s1 `seq` nd_C_mkVBalBranch x1 x4 x5
    (nd_C_filterWithKey x1 x2 x7 s0 cd cs) (nd_C_filterWithKey x1 x2 x8 s1 cd
    cs) s2 cd cs))))
  Curry_Prelude.C_False -> let s0 = s
    in s0 `seq` nd_C__case_36 x8 x2 x1 x7 (Curry_Prelude.d_C_otherwise cd cs) s0
    cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_37 x5 x4 x2 x8
    x1 x7 l s cd cs) (nd_C__case_37 x5 x4 x2 x8 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_37 x5
    x4 x2 x8 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_37 x5 x4
    x2 x8 x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_37"
    [show x5, show x4, show x2, show x8, show x1, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_37" (showCons x9))

d_C__case_36 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> (t1 -> Cover -> ConstStore -> t0 -> Cover -> ConstStore
  -> Curry_Prelude.C_Bool) -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_36 x8 x2 x1 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_glueVBal (d_C_filterWithKey x1 x2 x7 cd cs)
    (d_C_filterWithKey x1 x2 x8 cd cs) cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_36 x8 x2 x1 x7 l
    cd cs) (d_C__case_36 x8 x2 x1 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_36 x8
    x2 x1 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_36 x8 x2
    x1 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_36"
    [show x8, show x2, show x1, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_36" (showCons x9))

nd_C__case_36 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> Func t1 (Func t0 Curry_Prelude.C_Bool) -> Func
  Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1
  t0 -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_36 x8 x2 x1 x7 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s0 = leftSupply s2
                     s1 = rightSupply s2
    in s0 `seq` (s1 `seq` d_C_glueVBal (nd_C_filterWithKey x1 x2 x7 s0 cd cs)
    (nd_C_filterWithKey x1 x2 x8 s1 cd cs) cd cs))
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_36 x8 x2 x1 x7 l
    s cd cs) (nd_C__case_36 x8 x2 x1 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_36 x8
    x2 x1 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_36 x8 x2
    x1 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_36"
    [show x8, show x2, show x1, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_36" (showCons x9))

d_C__case_35 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> C_Map t1
  t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C__case_35 x4 x2 x1 x8 x5 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_lookup x1 x2 x7 cd cs
  Curry_Prelude.C_False -> d_C__case_34 x4 x2 x1 x8 x5 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x2 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_35 x4 x2 x1 x8 x5
    x7 l cd cs) (d_C__case_35 x4 x2 x1 x8 x5 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_35 x4
    x2 x1 x8 x5 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_35 x4 x2
    x1 x8 x5 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_35"
    [show x4, show x2, show x1, show x8, show x5, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_35" (showCons x9))

nd_C__case_35 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
nd_C__case_35 x4 x2 x1 x8 x5 x7 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_lookup x1 x2 x7 s0 cd cs
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_34 x4 x2 x1 x8 x5 (let s5 = leftSupply s6
                                                            s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x2 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_35 x4 x2 x1 x8
    x5 x7 l s cd cs) (nd_C__case_35 x4 x2 x1 x8 x5 x7 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_35 x4
    x2 x1 x8 x5 x7 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_35 x4 x2
    x1 x8 x5 x7 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_35"
    [show x4, show x2, show x1, show x8, show x5, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_35" (showCons x9))

d_C__case_34 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> Curry_Prelude.C_Maybe t0
d_C__case_34 x4 x2 x1 x8 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just x5
  Curry_Prelude.C_False -> d_C_lookup x1 x2 x8 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_34 x4 x2 x1 x8 x5
    l cd cs) (d_C__case_34 x4 x2 x1 x8 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_34 x4
    x2 x1 x8 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_34 x4 x2
    x1 x8 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_34"
    [show x4, show x2, show x1, show x8, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_34" (showCons x9))

nd_C__case_34 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe t0
nd_C__case_34 x4 x2 x1 x8 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just x5
  Curry_Prelude.C_False -> let s0 = s in s0 `seq` nd_C_lookup x1 x2 x8 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_34 x4 x2 x1 x8
    x5 l s cd cs) (nd_C__case_34 x4 x2 x1 x8 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_34 x4
    x2 x1 x8 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_34 x4 x2
    x1 x8 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_34"
    [show x4, show x2, show x1, show x8, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_34" (showCons x9))

d_C__case_33 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> Curry_Prelude.C_Maybe t0
  -> Cover -> ConstStore -> t0
d_C__case_33 x4 x3 x1 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_Nothing -> x2
  Curry_Prelude.C_Just x5 -> x5
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (d_C__case_33 x4 x3 x1 x2 l
    cd cs) (d_C__case_33 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> d_C__case_33 x4
    x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> d_C__case_33 x4 x3
    x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "Data.Map._case_33"
    [show x4, show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Map._case_33" (showCons x6))

nd_C__case_33 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> t0 -> Curry_Prelude.C_Maybe t0
  -> IDSupply -> Cover -> ConstStore -> t0
nd_C__case_33 x4 x3 x1 x2 x6 s cd cs = case x6 of
  Curry_Prelude.C_Nothing -> x2
  Curry_Prelude.C_Just x5 -> x5
  Curry_Prelude.Choice_C_Maybe d i l r -> narrow d i (nd_C__case_33 x4 x3 x1 x2
    l s cd cs) (nd_C__case_33 x4 x3 x1 x2 r s cd cs)
  Curry_Prelude.Choices_C_Maybe d i xs -> narrows cs d i (\z -> nd_C__case_33 x4
    x3 x1 x2 z s cd cs) xs
  Curry_Prelude.Guard_C_Maybe d c e -> guardCons d c ((\x -> nd_C__case_33 x4 x3
    x1 x2 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Maybe d info -> failCons d (traceFail "Data.Map._case_33"
    [show x4, show x3, show x1, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Map._case_33" (showCons x6))

d_C__case_32 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0)
d_C__case_32 x5 x3 x2 x6 cd cs = case x6 of
  Curry_Prelude.C_True -> d_C_lookupMin x5 cd cs
  Curry_Prelude.C_False -> d_C__case_31 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_32 x5 x3 x2 l cd
    cs) (d_C__case_32 x5 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_32 x5
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_32 x5 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_32"
    [show x5, show x3, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Map._case_32" (showCons x6))

d_C__case_31 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0)
d_C__case_31 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple2 x2 x3)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_31 x3 x2 l cd cs)
    (d_C__case_31 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_31 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_31 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_31"
    [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_31" (showCons x4))

d_C__case_30 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0)
d_C__case_30 x6 x3 x2 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_lookupMax x6 cd cs
  Curry_Prelude.C_False -> d_C__case_29 x3 x2 (Curry_Prelude.d_C_otherwise cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_30 x6 x3 x2 l cd
    cs) (d_C__case_30 x6 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_30 x6
    x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_30 x6 x3
    x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_30"
    [show x6, show x3, show x2, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_30" (showCons x7))

d_C__case_29 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore
  -> Curry_Prelude.C_Maybe (Curry_Prelude.OP_Tuple2 t1 t0)
d_C__case_29 x3 x2 x4 cd cs = case x4 of
  Curry_Prelude.C_True -> Curry_Prelude.C_Just (Curry_Prelude.OP_Tuple2 x2 x3)
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_29 x3 x2 l cd cs)
    (d_C__case_29 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_29 x3
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_29 x3 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_29"
    [show x3, show x2, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_29" (showCons x4))

d_C__case_28 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_28 x6 x5 x4 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C_mkBranch (Curry_Prelude.C_Int (1)) x1 x2 x3 x4 cd
    cs
  Curry_Prelude.C_False -> d_C__case_27 x5 x6 x4 x3 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) x6 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x5 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_28 x6 x5 x4 x3 x2
    x1 l cd cs) (d_C__case_28 x6 x5 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_28 x6
    x5 x4 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_28 x6 x5
    x4 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_28"
    [show x6, show x5, show x4, show x3, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_28" (showCons x7))

d_C__case_27 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_27 x5 x6 x4 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C__case_26 x3 x1 x2 x4 cd cs
  Curry_Prelude.C_False -> d_C__case_24 x6 x5 x4 x3 x2 x1
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) x5 cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x6 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_27 x5 x6 x4 x3 x2
    x1 l cd cs) (d_C__case_27 x5 x6 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_27 x5
    x6 x4 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_27 x5 x6
    x4 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_27"
    [show x5, show x6, show x4, show x3, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_27" (showCons x7))

d_C__case_24 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_24 x6 x5 x4 x3 x2 x1 x7 cd cs = case x7 of
  Curry_Prelude.C_True -> d_C__case_23 x4 x1 x2 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_21 x4 x3 x2 x1 (Curry_Prelude.d_C_otherwise
    cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_24 x6 x5 x4 x3 x2
    x1 l cd cs) (d_C__case_24 x6 x5 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_24 x6
    x5 x4 x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_24 x6 x5
    x4 x3 x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_24"
    [show x6, show x5, show x4, show x3, show x2, show x1, show x7] info)
  _ -> failCons cd (consFail "Data.Map._case_24" (showCons x7))

d_C__case_21 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_21 x4 x3 x2 x1 x5 cd cs = case x5 of
  Curry_Prelude.C_True -> d_C_mkBranch (Curry_Prelude.C_Int (2)) x1 x2 x3 x4 cd
    cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_21 x4 x3 x2 x1 l
    cd cs) (d_C__case_21 x4 x3 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_21 x4
    x3 x2 x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_21 x4 x3
    x2 x1 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_21"
    [show x4, show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_21" (showCons x5))

d_C__case_23 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C__case_23 x4 x1 x2 x3 cd cs = case x3 of
  C_Bin x12 x13 x14 x15 x16 -> d_C__case_22 x15 x16 x4 x3 x1 x2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) (d_C_size x16 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (Curry_Prelude.C_Int (2)) (d_C_size x15 cd cs) cd cs) cd cs) cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.mkBalBranch") cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_23 x4 x1 x2 l cd cs)
    (d_C__case_23 x4 x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_23 x4 x1 x2 z cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_23 x4 x1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_23" [show x4, show
    x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_23" (showCons x3))

d_C__case_22 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> C_Map t1 t0 -> C_Map t1 t0 -> t1 -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_22 x15 x16 x4 x3 x1 x2 x17 cd cs = case x17 of
  Curry_Prelude.C_True -> d_OP_mkBalBranch_dot_single_uscore_R_dot_236 x2 x1 x3
    x4 cd cs
  Curry_Prelude.C_False -> d_OP_mkBalBranch_dot_double_uscore_R_dot_236 x2 x1 x3
    x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_22 x15 x16 x4 x3
    x1 x2 l cd cs) (d_C__case_22 x15 x16 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_22 x15
    x16 x4 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_22 x15 x16
    x4 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_22"
    [show x15, show x16, show x4, show x3, show x1, show x2, show x17] info)
  _ -> failCons cd (consFail "Data.Map._case_22" (showCons x17))

d_C__case_26 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t1 -> t0 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C__case_26 x3 x1 x2 x4 cd cs = case x4 of
  C_Bin x7 x8 x9 x10 x11 -> d_C__case_25 x11 x10 x4 x3 x1 x2
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) (d_C_size x10 cd cs) cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (Curry_Prelude.C_Int (2)) (d_C_size x11 cd cs) cd cs) cd cs) cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.mkBalBranch") cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_26 x3 x1 x2 l cd cs)
    (d_C__case_26 x3 x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_26 x3 x1 x2 z cd cs)
    xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_26 x3 x1 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_26" [show x3, show
    x1, show x2, show x4] info)
  _ -> failCons cd (consFail "Data.Map._case_26" (showCons x4))

d_C__case_25 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> C_Map t1 t0 -> C_Map t1 t0 -> t1 -> t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_25 x11 x10 x4 x3 x1 x2 x12 cd cs = case x12 of
  Curry_Prelude.C_True -> d_OP_mkBalBranch_dot_single_uscore_L_dot_236 x2 x1 x3
    x4 cd cs
  Curry_Prelude.C_False -> d_OP_mkBalBranch_dot_double_uscore_L_dot_236 x2 x1 x3
    x4 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_25 x11 x10 x4 x3
    x1 x2 l cd cs) (d_C__case_25 x11 x10 x4 x3 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_25 x11
    x10 x4 x3 x1 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_25 x11 x10
    x4 x3 x1 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_25"
    [show x11, show x10, show x4, show x3, show x1, show x2, show x12] info)
  _ -> failCons cd (consFail "Data.Map._case_25" (showCons x12))

d_C__case_20 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_20 x9 x6 x5 x3 x1 x2 x8 cd cs = case x8 of
  C_Bin x10 x11 x12 x13 x14 -> d_C_mkBranch (Curry_Prelude.C_Int (5)) x10 x11
    (d_C_mkBranch (Curry_Prelude.C_Int (6)) x2 x1 x3 x13 cd cs) (d_C_mkBranch
    (Curry_Prelude.C_Int (7)) x5 x6 x14 x9 cd cs) cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.double_L") cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_20 x9 x6 x5 x3 x1 x2 l cd cs)
    (d_C__case_20 x9 x6 x5 x3 x1 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_20 x9 x6 x5 x3 x1 x2 z
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_20 x9 x6 x5 x3 x1 x2 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_20" [show x9, show
    x6, show x5, show x3, show x1, show x2, show x8] info)
  _ -> failCons cd (consFail "Data.Map._case_20" (showCons x8))

d_C__case_19 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0
  -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_19 x4 x1 x2 x8 x6 x5 x9 cd cs = case x9 of
  C_Bin x10 x11 x12 x13 x14 -> d_C_mkBranch (Curry_Prelude.C_Int (10)) x10 x11
    (d_C_mkBranch (Curry_Prelude.C_Int (11)) x5 x6 x8 x13 cd cs) (d_C_mkBranch
    (Curry_Prelude.C_Int (12)) x2 x1 x14 x4 cd cs) cd cs
  C_Tip -> Curry_Prelude.d_C_error (Curry_Prelude.toCurryString
    "Data.Map.double_R") cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_19 x4 x1 x2 x8 x6 x5 l cd cs)
    (d_C__case_19 x4 x1 x2 x8 x6 x5 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_19 x4 x1 x2 x8 x6 x5 z
    cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_19 x4 x1 x2 x8 x6 x5 e cd
    x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_19" [show x4, show
    x1, show x2, show x8, show x6, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_19" (showCons x9))

d_C__case_18 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0 -> t1 -> t0
  -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 x5 cd cs = case x5 of
  C_Tip -> d_C_insert x1 x2 x3 (C_Bin x6 x7 x8 x9 x10) cd cs
  C_Bin x11 x12 x13 x14 x15 -> let x16 = C_Bin x6 x7 x8 x9 x10
                                   x17 = C_Bin x11 x12 x13 x14 x15
                                   x18 = d_C_size x16 cd cs
                                   x19 = d_C_size x17 cd cs
    in d_C__case_17 x19 x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x18 cd cs) cd cs) x19 cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 l cd
    cs) (d_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_18 x10 x9 x8 x7 x6 x3
    x2 x1 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_18 x10 x9 x8 x7 x6 x3 x2
    x1 e cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_18" [show x10, show
    x9, show x8, show x7, show x6, show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_18" (showCons x5))

nd_C__case_18 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Int -> t0 -> t1 -> t0
  -> t1 -> Func Curry_Prelude.OP_Unit (Curry_Prelude.OP_uscore_Dict_hash_Ord t1)
  -> C_Map t1 t0 -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 x5 s cd cs = case x5 of
  C_Tip -> let s0 = s
    in s0 `seq` nd_C_insert x1 x2 x3 (C_Bin x6 x7 x8 x9 x10) s0 cd cs
  C_Bin x11 x12 x13 x14 x15 -> let s4 = s
    in s4 `seq` (let x16 = C_Bin x6 x7 x8 x9 x10
                     x17 = C_Bin x11 x12 x13 x14 x15
                     x18 = d_C_size x16 cd cs
                     x19 = d_C_size x17 cd cs
    in let s3 = leftSupply s4
           s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_17 x19 x18 x17 x16 x3 x2 x10 x1 x9 x7 x6
    x15 x14 x12 x11 (let s1 = leftSupply s2
                         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs))
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x18 cd cs) s0 cd cs) x19 s1 cd cs)) s3 cd cs))
  Choice_C_Map d i l r -> narrow d i (nd_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 l s
    cd cs) (nd_C__case_18 x10 x9 x8 x7 x6 x3 x2 x1 r s cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> nd_C__case_18 x10 x9 x8 x7 x6 x3
    x2 x1 z s cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> nd_C__case_18 x10 x9 x8 x7 x6 x3 x2
    x1 e s cd x) $! addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_18" [show x10, show
    x9, show x8, show x7, show x6, show x3, show x2, show x1, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_18" (showCons x5))

d_C__case_17 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> C_Map t1 t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> t1
  -> C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_17 x19 x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 x20 cd cs =
  case x20 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x11 x12 (d_C_mkVBalBranch x1 x2 x3 x16
    x14 cd cs) x15 cd cs
  Curry_Prelude.C_False -> d_C__case_16 x18 x19 x17 x16 x3 x2 x10 x1 x9 x7 x6
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x19 cd cs) cd cs) x18 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_17 x19 x18 x17
    x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 l cd cs) (d_C__case_17 x19 x18 x17
    x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_17 x19
    x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_17 x19 x18
    x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_17"
    [show x19, show x18, show x17, show x16, show x3, show x2, show x10, show x1
    , show x9, show x7, show x6, show x15, show x14, show x12, show x11, show
    x20] info)
  _ -> failCons cd (consFail "Data.Map._case_17" (showCons x20))

nd_C__case_17 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> C_Map t1 t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> t1 -> C_Map
  t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> IDSupply -> Cover
  -> ConstStore -> C_Map t1 t0
nd_C__case_17 x19 x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 x20 s cd cs =
  case x20 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x11 x12 (nd_C_mkVBalBranch x1 x2 x3 x16 x14 s0
    cd cs) x15 cd cs
  Curry_Prelude.C_False -> let s4 = s
    in s4 `seq` (let s3 = leftSupply s4
                     s2 = rightSupply s4
    in s3 `seq` (s2 `seq` nd_C__case_16 x18 x19 x17 x16 x3 x2 x10 x1 x9 x7 x6
    (let s1 = leftSupply s2
         s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_C_apply (Curry_Prelude.nd_C_apply
    (wrapDX (wrapDX id)
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs))
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x19 cd cs) s0 cd cs) x18 s1 cd cs)) s3 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_17 x19 x18 x17
    x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 l s cd cs) (nd_C__case_17 x19 x18
    x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_17 x19
    x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_17 x19
    x18 x17 x16 x3 x2 x10 x1 x9 x7 x6 x15 x14 x12 x11 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_17"
    [show x19, show x18, show x17, show x16, show x3, show x2, show x10, show x1
    , show x9, show x7, show x6, show x15, show x14, show x12, show x11, show
    x20] info)
  _ -> failCons cd (consFail "Data.Map._case_17" (showCons x20))

d_C__case_16 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> C_Map t1 t0 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> t1
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_16 x18 x19 x17 x16 x3 x2 x10 x1 x9 x7 x6 x20 cd cs = case x20 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x6 x7 x9 (d_C_mkVBalBranch x1 x2 x3
    x10 x17 cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_15 x17 x16 x3 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_16 x18 x19 x17
    x16 x3 x2 x10 x1 x9 x7 x6 l cd cs) (d_C__case_16 x18 x19 x17 x16 x3 x2 x10
    x1 x9 x7 x6 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_16 x18
    x19 x17 x16 x3 x2 x10 x1 x9 x7 x6 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_16 x18 x19
    x17 x16 x3 x2 x10 x1 x9 x7 x6 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_16"
    [show x18, show x19, show x17, show x16, show x3, show x2, show x10, show x1
    , show x9, show x7, show x6, show x20] info)
  _ -> failCons cd (consFail "Data.Map._case_16" (showCons x20))

nd_C__case_16 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> t0 -> t1 -> C_Map t1 t0 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> t0 -> t1
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_16 x18 x19 x17 x16 x3 x2 x10 x1 x9 x7 x6 x20 s cd cs = case x20 of
  Curry_Prelude.C_True -> let s0 = s
    in s0 `seq` d_C_mkBalBranch x6 x7 x9 (nd_C_mkVBalBranch x1 x2 x3 x10 x17 s0
    cd cs) cd cs
  Curry_Prelude.C_False -> d_C__case_15 x17 x16 x3 x2
    (Curry_Prelude.d_C_otherwise cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_16 x18 x19 x17
    x16 x3 x2 x10 x1 x9 x7 x6 l s cd cs) (nd_C__case_16 x18 x19 x17 x16 x3 x2
    x10 x1 x9 x7 x6 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_16 x18
    x19 x17 x16 x3 x2 x10 x1 x9 x7 x6 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_16 x18
    x19 x17 x16 x3 x2 x10 x1 x9 x7 x6 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_16"
    [show x18, show x19, show x17, show x16, show x3, show x2, show x10, show x1
    , show x9, show x7, show x6, show x20] info)
  _ -> failCons cd (consFail "Data.Map._case_16" (showCons x20))

d_C__case_15 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_15 x17 x16 x3 x2 x18 cd cs = case x18 of
  Curry_Prelude.C_True -> d_C_mkBranch (Curry_Prelude.C_Int (13)) x2 x3 x16 x17
    cd cs
  Curry_Prelude.C_False -> Curry_Prelude.d_C_failed cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_15 x17 x16 x3 x2
    l cd cs) (d_C__case_15 x17 x16 x3 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_15 x17
    x16 x3 x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_15 x17 x16
    x3 x2 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_15"
    [show x17, show x16, show x3, show x2, show x18] info)
  _ -> failCons cd (consFail "Data.Map._case_15" (showCons x18))

d_C__case_14 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_14 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> d_C__case_13 x2 x1 (d_C_null x2 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_14 x1 x2 l cd cs)
    (d_C__case_14 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_14 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_14 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_14"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_14" (showCons x3))

d_C__case_13 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_13 x2 x1 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> let x3 = d_C_findMax x1 cd cs
                               x4 = d_OP_glueBal_dot_uscore_hash_selFP15_hash_mid_uscore_key1
                                 x3 cd cs
                               x5 = d_OP_glueBal_dot_uscore_hash_selFP16_hash_mid_uscore_elt1
                                 x3 cd cs
                               x6 = d_C_findMin x2 cd cs
                               x7 = d_OP_glueBal_dot_uscore_hash_selFP13_hash_mid_uscore_key2
                                 x6 cd cs
                               x8 = d_OP_glueBal_dot_uscore_hash_selFP14_hash_mid_uscore_elt2
                                 x6 cd cs
    in d_C__case_12 x1 x2 x5 x4 x8 x7 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_gt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs) (d_C_size x2 cd cs) cd cs) (d_C_size x1 cd cs) cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_13 x2 x1 l cd cs)
    (d_C__case_13 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_13 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_13 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_13"
    [show x2, show x1, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_13" (showCons x9))

d_C__case_12 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> t0 -> t1
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_12 x1 x2 x5 x4 x8 x7 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x7 x8 x1 (d_C_deleteMin x2 cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C_mkBalBranch x4 x5 (d_C_deleteMax x1 cd cs) x2 cd
    cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_12 x1 x2 x5 x4 x8
    x7 l cd cs) (d_C__case_12 x1 x2 x5 x4 x8 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_12 x1
    x2 x5 x4 x8 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_12 x1 x2
    x5 x4 x8 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_12"
    [show x1, show x2, show x5, show x4, show x8, show x7, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_12" (showCons x9))

d_C__case_11 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_11 x1 x2 x3 cd cs = case x3 of
  Curry_Prelude.C_True -> x2
  Curry_Prelude.C_False -> d_C__case_10 x2 x1 (d_C_null x2 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_11 x1 x2 l cd cs)
    (d_C__case_11 x1 x2 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_11 x1
    x2 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_11 x1 x2 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_11"
    [show x1, show x2, show x3] info)
  _ -> failCons cd (consFail "Data.Map._case_11" (showCons x3))

d_C__case_10 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> C_Map t1 t0 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_10 x2 x1 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> x1
  Curry_Prelude.C_False -> let x3 = d_OP_glueVBal_dot_uscore_hash_selFP23_hash_key_uscore_l
                                 x1 cd cs
                               x4 = d_OP_glueVBal_dot_uscore_hash_selFP24_hash_elt_uscore_l
                                 x1 cd cs
                               x5 = d_OP_glueVBal_dot_uscore_hash_selFP25_hash_fm_uscore_ll
                                 x1 cd cs
                               x6 = d_OP_glueVBal_dot_uscore_hash_selFP26_hash_fm_uscore_lr
                                 x1 cd cs
                               x7 = d_OP_glueVBal_dot_uscore_hash_selFP19_hash_key_uscore_r
                                 x2 cd cs
                               x8 = d_OP_glueVBal_dot_uscore_hash_selFP20_hash_elt_uscore_r
                                 x2 cd cs
                               x9 = d_OP_glueVBal_dot_uscore_hash_selFP21_hash_fm_uscore_rl
                                 x2 cd cs
                               x10 = d_OP_glueVBal_dot_uscore_hash_selFP22_hash_fm_uscore_rr
                                 x2 cd cs
                               x11 = d_C_size x1 cd cs
                               x12 = d_C_size x2 cd cs
    in d_C__case_9 x12 x11 x2 x1 x6 x5 x4 x3 x10 x9 x8 x7
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x11 cd cs) cd cs) x12 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_10 x2 x1 l cd cs)
    (d_C__case_10 x2 x1 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_10 x2
    x1 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_10 x2 x1 e
    cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_10"
    [show x2, show x1, show x13] info)
  _ -> failCons cd (consFail "Data.Map._case_10" (showCons x13))

d_C__case_9 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_9 x12 x11 x2 x1 x6 x5 x4 x3 x10 x9 x8 x7 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x7 x8 (d_C_glueVBal x1 x9 cd cs) x10
    cd cs
  Curry_Prelude.C_False -> d_C__case_8 x11 x12 x2 x1 x6 x5 x4 x3
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_OP_uscore_impl_hash_lt_hash_Prelude_dot_Ord_hash_Prelude_dot_Int
    cd cs)
    (Curry_Prelude.d_OP_uscore_impl_hash_star_hash_Prelude_dot_Num_hash_Prelude_dot_Int
    (d_C_sIZE_RATIO cd cs) x12 cd cs) cd cs) x11 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_9 x12 x11 x2 x1
    x6 x5 x4 x3 x10 x9 x8 x7 l cd cs) (d_C__case_9 x12 x11 x2 x1 x6 x5 x4 x3 x10
    x9 x8 x7 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_9 x12
    x11 x2 x1 x6 x5 x4 x3 x10 x9 x8 x7 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_9 x12 x11
    x2 x1 x6 x5 x4 x3 x10 x9 x8 x7 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_9"
    [show x12, show x11, show x2, show x1, show x6, show x5, show x4, show x3
    , show x10, show x9, show x8, show x7, show x13] info)
  _ -> failCons cd (consFail "Data.Map._case_9" (showCons x13))

d_C__case_8 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => Curry_Prelude.C_Int -> Curry_Prelude.C_Int -> C_Map t1 t0 -> C_Map t1
  t0 -> C_Map t1 t0 -> C_Map t1 t0 -> t0 -> t1 -> Curry_Prelude.C_Bool -> Cover
  -> ConstStore -> C_Map t1 t0
d_C__case_8 x11 x12 x2 x1 x6 x5 x4 x3 x13 cd cs = case x13 of
  Curry_Prelude.C_True -> d_C_mkBalBranch x3 x4 x5 (d_C_glueVBal x6 x2 cd cs) cd
    cs
  Curry_Prelude.C_False -> d_C_glueBal x1 x2 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_8 x11 x12 x2 x1
    x6 x5 x4 x3 l cd cs) (d_C__case_8 x11 x12 x2 x1 x6 x5 x4 x3 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_8 x11
    x12 x2 x1 x6 x5 x4 x3 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_8 x11 x12
    x2 x1 x6 x5 x4 x3 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_8"
    [show x11, show x12, show x2, show x1, show x6, show x5, show x4, show x3
    , show x13] info)
  _ -> failCons cd (consFail "Data.Map._case_8" (showCons x13))

d_C__case_7 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_7 x4 x3 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_splitLT x1 x7 x3 cd cs
  Curry_Prelude.C_False -> d_C__case_6 x4 x3 x1 x8 x7 x5
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x3 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_7 x4 x3 x1 x8 x7
    x5 l cd cs) (d_C__case_7 x4 x3 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_7 x4 x3
    x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_7 x4 x3 x1
    x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_7"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_7" (showCons x9))

nd_C__case_7 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_7 x4 x3 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s0 = s in s0 `seq` nd_C_splitLT x1 x7 x3 s0 cd cs
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_6 x4 x3 x1 x8 x7 x5 (let s5 = leftSupply s6
                                                              s4 = rightSupply
                                                                s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x3 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_7 x4 x3 x1 x8 x7
    x5 l s cd cs) (nd_C__case_7 x4 x3 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_7 x4
    x3 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_7 x4 x3
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_7"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_7" (showCons x9))

d_C__case_6 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_6 x4 x3 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x7
  Curry_Prelude.C_False -> d_C_mkVBalBranch x1 x4 x5 x7 (d_C_splitLT x1 x8 x3 cd
    cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_6 x4 x3 x1 x8 x7
    x5 l cd cs) (d_C__case_6 x4 x3 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_6 x4 x3
    x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_6 x4 x3 x1
    x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_6"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_6" (showCons x9))

nd_C__case_6 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_6 x4 x3 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> x7
  Curry_Prelude.C_False -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_mkVBalBranch x1 x4 x5 x7 (nd_C_splitLT x1 x8 x3
    s0 cd cs) s1 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_6 x4 x3 x1 x8 x7
    x5 l s cd cs) (nd_C__case_6 x4 x3 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_6 x4
    x3 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_6 x4 x3
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_6"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_6" (showCons x9))

d_C__case_5 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0
  -> t0 -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_5 x4 x3 x1 x8 x7 x5 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> d_C_mkVBalBranch x1 x4 x5 (d_C_splitGT x1 x7 x3 cd cs)
    x8 cd cs
  Curry_Prelude.C_False -> d_C__case_4 x4 x3 x1 x8 (Curry_Prelude.d_C_apply
    (Curry_Prelude.d_C_apply (Curry_Prelude.d_OP_eq_eq
    (Curry_Prelude.d_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq x1
    cd cs) cd cs) x3 cd cs) x4 cd cs) cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_5 x4 x3 x1 x8 x7
    x5 l cd cs) (d_C__case_5 x4 x3 x1 x8 x7 x5 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_5 x4 x3
    x1 x8 x7 x5 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_5 x4 x3 x1
    x8 x7 x5 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_5"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_5" (showCons x9))

nd_C__case_5 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0 -> C_Map t1 t0 -> t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_5 x4 x3 x1 x8 x7 x5 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> let s2 = s
    in s2 `seq` (let s1 = leftSupply s2
                     s0 = rightSupply s2
    in s1 `seq` (s0 `seq` nd_C_mkVBalBranch x1 x4 x5 (nd_C_splitGT x1 x7 x3 s0
    cd cs) x8 s1 cd cs))
  Curry_Prelude.C_False -> let s8 = s
    in s8 `seq` (let s7 = leftSupply s8
                     s6 = rightSupply s8
    in s7 `seq` (s6 `seq` nd_C__case_4 x4 x3 x1 x8 (let s5 = leftSupply s6
                                                        s4 = rightSupply s6
    in s5 `seq` (s4 `seq` Curry_Prelude.nd_C_apply (let s3 = leftSupply s4
                                                        s2 = rightSupply s4
    in s3 `seq` (s2 `seq` Curry_Prelude.nd_C_apply (let s1 = leftSupply s2
                                                        s0 = rightSupply s2
    in s1 `seq` (s0 `seq` Curry_Prelude.nd_OP_eq_eq
    (Curry_Prelude.nd_OP_uscore_super_hash_Prelude_dot_Ord_hash_Prelude_dot_Eq
    x1 s0 cd cs) s1 cd cs)) x3 s3 cd cs)) x4 s5 cd cs)) s7 cd cs))
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_5 x4 x3 x1 x8 x7
    x5 l s cd cs) (nd_C__case_5 x4 x3 x1 x8 x7 x5 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_5 x4
    x3 x1 x8 x7 x5 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_5 x4 x3
    x1 x8 x7 x5 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_5"
    [show x4, show x3, show x1, show x8, show x7, show x5, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_5" (showCons x9))

d_C__case_4 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> (Curry_Prelude.OP_Unit -> Cover -> ConstStore
  -> Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> Cover -> ConstStore -> C_Map t1 t0
d_C__case_4 x4 x3 x1 x8 x9 cd cs = case x9 of
  Curry_Prelude.C_True -> x8
  Curry_Prelude.C_False -> d_C_splitGT x1 x8 x3 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (d_C__case_4 x4 x3 x1 x8 l
    cd cs) (d_C__case_4 x4 x3 x1 x8 r cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> d_C__case_4 x4 x3
    x1 x8 z cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> d_C__case_4 x4 x3 x1
    x8 e cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_4"
    [show x4, show x3, show x1, show x8, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_4" (showCons x9))

nd_C__case_4 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => t1 -> t1 -> Func Curry_Prelude.OP_Unit
  (Curry_Prelude.OP_uscore_Dict_hash_Ord t1) -> C_Map t1 t0
  -> Curry_Prelude.C_Bool -> IDSupply -> Cover -> ConstStore -> C_Map t1 t0
nd_C__case_4 x4 x3 x1 x8 x9 s cd cs = case x9 of
  Curry_Prelude.C_True -> x8
  Curry_Prelude.C_False -> let s0 = s in s0 `seq` nd_C_splitGT x1 x8 x3 s0 cd cs
  Curry_Prelude.Choice_C_Bool d i l r -> narrow d i (nd_C__case_4 x4 x3 x1 x8 l
    s cd cs) (nd_C__case_4 x4 x3 x1 x8 r s cd cs)
  Curry_Prelude.Choices_C_Bool d i xs -> narrows cs d i (\z -> nd_C__case_4 x4
    x3 x1 x8 z s cd cs) xs
  Curry_Prelude.Guard_C_Bool d c e -> guardCons d c ((\x -> nd_C__case_4 x4 x3
    x1 x8 e s cd x) $! addCs c cs)
  Curry_Prelude.Fail_C_Bool d info -> failCons d (traceFail "Data.Map._case_4"
    [show x4, show x3, show x1, show x8, show x9] info)
  _ -> failCons cd (consFail "Data.Map._case_4" (showCons x9))

d_C__case_3 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> C_Map t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
d_C__case_3 x3 x2 x5 cd cs = case x5 of
  C_Tip -> Curry_Prelude.OP_Tuple2 x2 x3
  C_Bin x7 x8 x9 x10 x11 -> d_C_findMin (C_Bin x7 x8 x9 x10 x11) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_3 x3 x2 l cd cs) (d_C__case_3 x3
    x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_3 x3 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_3 x3 x2 e cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_3" [show x3, show
    x2, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_3" (showCons x5))

d_C__case_2 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C__case_2 x6 x3 x2 x5 cd cs = case x5 of
  C_Tip -> x6
  C_Bin x7 x8 x9 x10 x11 -> d_C_mkBalBranch x2 x3 (d_C_deleteMin (C_Bin x7 x8 x9
    x10 x11) cd cs) x6 cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_2 x6 x3 x2 l cd cs) (d_C__case_2
    x6 x3 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_2 x6 x3 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_2 x6 x3 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_2" [show x6, show
    x3, show x2, show x5] info)
  _ -> failCons cd (consFail "Data.Map._case_2" (showCons x5))

d_C__case_1 :: forall t0 t1 . (Curry_Prelude.Curry t0, Curry_Prelude.Curry
  t1) => t0 -> t1 -> C_Map t1 t0 -> Cover -> ConstStore
  -> Curry_Prelude.OP_Tuple2 t1 t0
d_C__case_1 x3 x2 x6 cd cs = case x6 of
  C_Tip -> Curry_Prelude.OP_Tuple2 x2 x3
  C_Bin x7 x8 x9 x10 x11 -> d_C_findMax (C_Bin x7 x8 x9 x10 x11) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_1 x3 x2 l cd cs) (d_C__case_1 x3
    x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_1 x3 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_1 x3 x2 e cd x) $! addCs
    c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_1" [show x3, show
    x2, show x6] info)
  _ -> failCons cd (consFail "Data.Map._case_1" (showCons x6))

d_C__case_0 :: forall t1 t0 . (Curry_Prelude.Curry t1, Curry_Prelude.Curry
  t0) => C_Map t1 t0 -> t0 -> t1 -> C_Map t1 t0 -> Cover -> ConstStore -> C_Map
  t1 t0
d_C__case_0 x5 x3 x2 x6 cd cs = case x6 of
  C_Tip -> x5
  C_Bin x7 x8 x9 x10 x11 -> d_C_mkBalBranch x2 x3 x5 (d_C_deleteMax (C_Bin x7 x8
    x9 x10 x11) cd cs) cd cs
  Choice_C_Map d i l r -> narrow d i (d_C__case_0 x5 x3 x2 l cd cs) (d_C__case_0
    x5 x3 x2 r cd cs)
  Choices_C_Map d i xs -> narrows cs d i (\z -> d_C__case_0 x5 x3 x2 z cd cs) xs
  Guard_C_Map d c e -> guardCons d c ((\x -> d_C__case_0 x5 x3 x2 e cd x) $!
    addCs c cs)
  Fail_C_Map d info -> failCons d (traceFail "Data.Map._case_0" [show x5, show
    x3, show x2, show x6] info)
  _ -> failCons cd (consFail "Data.Map._case_0" (showCons x6))

